<?php
/** 
 * Plugin Name: Cyber Fundraiser Lite
 * Plugin URI: http://products.cybersourcepk.com/cyber-fundraiser/
 * Description: Cyber Fundraiser is the most robust, flexible, and intuitive way to accept donations on WordPress.
 * Version: 0.1.0
 * Author: cybersourcepk
 * Author URI: http://www.cybersourcepk.com/
 *
 * Text Domain: cyber-fundraiser-lite
 * 
 * Domain Path: /languages
 *
 * @author      Cybersourcepk
 * @category    Core
 * @package     fundraiser
 * @version     0.1.0
 
 * License: GNU General Public License v3.0
 *
 * License URI: http://www.gnu.org/licenses/gpl-3.0.html
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;   //Exit if accessed directly.
}
// Let the Constants be
define('CYBER_FRL_ROOT_PATH', dirname(__FILE__));
define('CYBER_FRL_ROOT_URL', plugins_url('', __FILE__));
define('CYBER_FRL_PLUGIN_VERSION', '0.1.0');

// including Files
include CYBER_FRL_ROOT_PATH.'/includes/admin/functions.php';
include CYBER_FRL_ROOT_PATH.'/includes/admin/facebook.php';
include CYBER_FRL_ROOT_PATH.'/includes/admin/class.admin.dashboard.php';
include CYBER_FRL_ROOT_PATH.'/includes/admin/class.admin.menus.php';
include CYBER_FRL_ROOT_PATH.'/includes/admin/cyber.ajax.functions.php';
include CYBER_FRL_ROOT_PATH.'/includes/widgets/class.donation.widget.php';
include CYBER_FRL_ROOT_PATH.'/includes/admin/class.cyber_statistics.php';
include CYBER_FRL_ROOT_PATH.'/includes/widgets/class.fundraiser.twitterfeeds.widget.php';
include CYBER_FRL_ROOT_PATH.'/includes/widgets/class.fundraiser.facebookfeeds.widget.php';
include CYBER_FRL_ROOT_PATH.'/includes/shortcodes/class.donation.shortcode.php';
include CYBER_FRL_ROOT_PATH.'/includes/shortcodes/views/success_page.php';
include CYBER_FRL_ROOT_PATH.'/includes/shortcodes/paypal-shortcode.php';
include CYBER_FRL_ROOT_PATH.'/includes/frontend/class.cyber.fundraiser.frontend.php';
include CYBER_FRL_ROOT_PATH.'/includes/frontend/class.cyber.emails.php';
include CYBER_FRL_ROOT_PATH.'/includes/shortcodes/class.twitter.feeds.shortcode.php';
include CYBER_FRL_ROOT_PATH.'/includes/shortcodes/class.facebook.feeds.shortcode.php';
include CYBER_FRL_ROOT_PATH.'/cyber-one-click-demo-install/init.php';
include CYBER_FRL_ROOT_PATH.'/includes/shortcodes/class.projects.shortcode.php';

$dashboard = new Cyber_frl_Admin_Dashboard;
$statistics = new Cyber_frl_Site_Statistics;

register_activation_hook(__FILE__, 'cyberfundraising_lite_activation_hook');
/**
 * Adding Option on Activation.
 * Then check and Redirect to Welcome Page
 * @return ''
 */

if(!function_exists('cyberfundraising_lite_activation_hook')){
	function cyberfundraising_lite_activation_hook(){
		
		if(is_plugin_active('cyber-fundraiser/cyber-fundraiser.php')){
				deactivate_plugins('cyber-fundraiser/cyber-fundraiser.php');
		}
		global $wpdb;
		
		// add option to check for redirection to dashboard on activation
		add_option('cyber_fundraising_activation_redirect', true);

		add_action('wp_insert_post', cyber_frl_create_frontend_page()); // Creating frontend pages

		add_action('wp_insert_post', cyber_frl_create_success_page());

		add_action('wp_insert_post', cyber_frl_create_become_fundraiser_page());
		
		add_action('wp_insert_post', cyber_frl_create_docs_page());
		
		
		// creating tables on activation
		cyber_frl_create_tables();


	}
}
add_action('do_meta_boxes', 'cyber_frl_replace_featured_image_to_cyber_project_image');
add_action('admin_init', 'cyber_fundraising_activation_redirect'); 
add_action( 'init', 'cyber_fundraiser_load_translation_files');
add_action( 'init', 'cyber_frl_add_rewrite_rules' );
add_action('init', 'cyber_frl_do_output_buffer');

if(!function_exists('cyber_fundraiser_load_translation_files')){
	function cyber_fundraiser_load_translation_files() {
		load_plugin_textdomain('cyber-fundraiser', false, basename( dirname( __FILE__ ) ) . '/languages');
	}
}
/**
 * Check the option we added on Activation.
 * If exist. Delete it
 * Now Calling the static method to redirect to Welcome page
 * @return 'redirect'
 */
 
if(!function_exists('cyber_fundraising_activation_redirect')){
	function cyber_fundraising_activation_redirect() {

		if (get_option('cyber_fundraising_activation_redirect', false)) {
			delete_option('cyber_fundraising_activation_redirect');
			Cyber_frl_Admin_Dashboard::new_user_redirect();
		}
	}
}

/**
 * Creating Frontend Page
 * @return Array
 */
if(!function_exists('cyber_frl_create_frontend_page')){
	function cyber_frl_create_frontend_page(){

		if (! Cyber_frl_Admin_Menus::get_page_by_slug('cyber-fundraiser-checkout') ) {
		   
		   $post = array(
			  'comment_status' => 'closed',
			  'ping_status' =>  'closed' ,
			  'post_author' => 1,
			  'post_date' => date('Y-m-d H:i:s'),
			  'post_name' => 'Cyber Fundraiser Checkout',
			  'post_status' => 'publish' ,
			  'post_title' => 'Cyber Fundraiser Checkout',
			  'post_type' => 'page',
			  'post_content' => '[cyber_checkout]',
			);  
			//insert page and save the id
			$page_id = wp_insert_post( $post, false );

		}

	}
}

if(!function_exists('cyber_frl_create_success_page')){
	function cyber_frl_create_success_page(){

		if (! Cyber_frl_Admin_Menus::get_page_by_slug('cyber-fundraiser-success-donation') ) {
		   
		   $post = array(
			  'comment_status' => 'closed',
			  'ping_status' =>  'closed' ,
			  'post_author' => 1,
			  'post_date' => date('Y-m-d H:i:s'),
			  'post_name' => 'Cyber Fundraiser Success Donation',
			  'post_status' => 'publish' ,
			  'post_title' => 'Cyber Fundraiser Success Donation',
			  'post_type' => 'page',
			  'post_content' => '[cyber_success_donation]',
			);  
			//insert page and save the id
			$page_id = wp_insert_post( $post, false );

		}

	}
}

if(!function_exists('cyber_frl_create_become_fundraiser_page')){
	function cyber_frl_create_become_fundraiser_page(){

		if (! Cyber_frl_Admin_Menus::get_page_by_slug('child-project') ) {
		   
		   $post = array(
			  'comment_status' => 'closed',
			  'ping_status' =>  'closed' ,
			  'post_author' => 1,
			  'post_date' => date('Y-m-d H:i:s'),
			  'post_name' => 'Child Project',
			  'post_status' => 'publish' ,
			  'post_title' => 'Become A Fundraiser',
			  'post_type' => 'page',
			  'post_content' => '[cyber_become_fundraiser]',
			);  
			//insert page and save the id
			$page_id = wp_insert_post( $post, false );

		}

	}
}

if(!function_exists('cyber_frl_create_docs_page')){	
	function cyber_frl_create_docs_page(){

		if (! Cyber_frl_Admin_Menus::get_page_by_slug('cf-docs') ) {
		   
		   $post = array(
			  'comment_status' => 'closed',
			  'ping_status' =>  'closed' ,
			  'post_author' => 1,
			  'post_date' => date('Y-m-d H:i:s'),
			  'post_name' => 'cf-docs',
			  'post_status' => 'publish' ,
			  'post_title' => 'Cyber Fundraiser Documentation',
			  'post_type' => 'page',
			  'post_content' => '[cyber-help]',
			);  
			//insert page and save the id
			$page_id = wp_insert_post( $post, false );

		}

	}
}

// Cyber table  for donation
if(!function_exists('cyber_frl_create_tables')){
	function cyber_frl_create_tables(){

		// Let the $wpdb global
		global $wpdb;
		$charset_collate = '';
		$cyber_donations = $wpdb->prefix . "cyber_donations";
		$cyber_guest_donations = $wpdb->prefix . "cyber_guest_donations";

		// Get DB collate
		if(!empty($wpdb->charset)) {
			$charset_collate = "DEFAULT CHARACTER SET $wpdb->charset";
		}

		// if not empty
		if(!empty($wpdb->collate)) {
			$charset_collate .= " COLLATE $wpdb->collate";
		}

		// Building the query. Creating table for Donations
		if($wpdb->get_var("SHOW TABLES LIKE {$cyber_donations}")!=$cyber_donations){
			$cyber_donations = "CREATE TABLE $cyber_donations (
					  id int(10) NOT NULL AUTO_INCREMENT,
					  user_id int(10) NULL,
					  guest_id int(10) NULL ,
					  donation_amount varchar(55) NOT NULL,
					  payment_status varchar(50) NOT NULL,
					  project_id int(11) NULL,
					  child_project_id int(11) NULL,
					  donor_comments varchar(100) NULL,
					  paid_via varchar(70) NULL,
					  date_created datetime NOT NULL,
					  transaction_id text NULL,
					  PRIMARY KEY  (id)
					) $charset_collate;";
		}

		// Building the query. Creating table for Guest Donations
		if($wpdb->get_var("SHOW TABLES LIKE {$cyber_guest_donations}")!=$cyber_guest_donations){
			$cyber_guest_donations = "CREATE TABLE $cyber_guest_donations (
					  id int(10) NOT NULL AUTO_INCREMENT,
					 
					  country varchar(50) NULL,
					  title varchar(10) NULL,
					  fname varchar(50) NULL,
					  mname varchar(50) NULL,
					  lname varchar(50) NULL,
					  comp_name varchar(50) NULL,
					  address varchar(255) NULL,
					  city_name varchar(50) NULL,
					  zipcode int(11) NULL,
					  email varchar(50) NULL,
					  phone varchar(20) NULL,
					  PRIMARY KEY  (id)
					) $charset_collate;";
		}

		
		//statistics tables
		
			$visitors_table_name=$wpdb->prefix.'cyber_statistics_visitors';
			if($wpdb->get_var("SHOW TABLES LIKE {$visitors_table_name}")!=$visitors_table_name)
			{
				$create_visitors_table = ("CREATE TABLE {$visitors_table_name} (
						ID int(11) NOT NULL AUTO_INCREMENT,
						last_counter date NOT NULL,
						referred text NULL,
						browser_info text NOT NULL,
						ip varchar(60) NOT NULL,
						location varchar(15),
						PRIMARY KEY  (ID)
						) CHARSET=utf8");
			}
				
			$visits_table_name =$wpdb->prefix.'cyber_statistics_visits';
			if($wpdb->get_var("SHOW TABLES LIKE {$visits_table_name}")!=$visits_table_name)
			{
					$create_visits_table = ("CREATE TABLE {$visits_table_name} (
						ID int(11) NOT NULL AUTO_INCREMENT,
						last_visit datetime NOT NULL,
						last_counter date NOT NULL,
						page text NOT NULL,
						ip varchar(60) NOT NULL, 
						visits int(10) NOT NULL,
						PRIMARY KEY  (ID)
						) CHARSET=utf8");
			}

		// Executing the query
		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

		// Execute the query one by one
		dbDelta($cyber_donations);
		dbDelta($cyber_guest_donations);

		//statistics tables
		dbDelta($create_visitors_table);
		dbDelta($create_visits_table);

	}
}
//allow redirection, even if my plugin starts to send output to the browser
if(!function_exists('cyber_frl_do_output_buffer')){
	function cyber_frl_do_output_buffer() {
				ob_start();
	}
}

if(!function_exists('cyber_frl_StartSession')){
	function cyber_frl_StartSession() {
		if(session_status() === PHP_SESSION_NONE) {
			session_start();
		}
	}
}
//user redirect when logged in to donate
if(!function_exists('cyber_frl_login_redirect')){
	function cyber_frl_login_redirect($redirect_to, $request, $user){
		
		 if ( isset( $user->roles ) && is_array( $user->roles ) ) {
		 
			  //check for admins
				if ( in_array( 'administrator', $user->roles ) ) {
				
				   // redirect them to the default place
				   return $redirect_to;
				  } 
				  else{
						if(strpos($request, 'project_id=') !==false){
								$previous_location = $_SESSION['previous_location'];
								
								return $previous_location;

						}elseif(strpos($_SERVER['HTTP_REFERER'], 'project_id=') !==false){
							
								$previous_location = $_SESSION['previous_location'];
								return $previous_location;
						}else{
							return home_url();
						}
				
					}
			} else{
			  
				return $redirect_to;
			}
	}
}
//filter to reidrect user when the user loggedin for donation 
add_filter( 'login_redirect', 'cyber_frl_login_redirect', 10, 3 );


// change featured image label to project image label
if(!function_exists('cyber_frl_replace_featured_image_to_cyber_project_image')){
	function cyber_frl_replace_featured_image_to_cyber_project_image()  {  
			remove_meta_box( 'postimagediv', 'projects', 'side' );

			add_meta_box('postimagediv', __('Project Image'), 'post_thumbnail_meta_box', 'projects', 'side', 'low');  
	}  
}
// Cyber Fundraiser admin footer text
if(!function_exists('cyber_frl_fundraiser_admin_rate_us')){
	function cyber_frl_fundraiser_admin_rate_us( $footer_text ) {
		
		$rate_text = sprintf( '<strong>'.__( " Powered By", 'cyber-fundraiser-lite' ).': %sCybersourcepk%s </strong>' ,'<a href="http://www.cybersourcepk.com" target="_blank">', '</a>' );
		  
				return $rate_text;
			
	}
}
add_filter( 'admin_footer_text', 'cyber_frl_fundraiser_admin_rate_us' );

//Change the Default avatar to cyber Fundraiser Avatar
add_filter( 'avatar_defaults', 'cyber_frl_fundraiser_avatar' );
if(!function_exists('cyber_frl_fundraiser_avatar')){
	function cyber_frl_fundraiser_avatar ( $avatar_defaults ) {

		  //Set the URL where the image file for your avatar is located
		  $new_cyber_fundraiser_avatar_url = CYBER_FRL_ROOT_URL.'/assets/images/avatar.png';
		 
		  //Set the text that will appear to the right of your avatar in Settings >> Discussion
		  $avatar_defaults[$new_cyber_fundraiser_avatar_url] = 'Cyber Fundraiser Avatar';
		  
		  return $avatar_defaults;
	}
}

if(!function_exists('cyber_frl_add_rewrite_rules')){
	function cyber_frl_add_rewrite_rules() {
		add_rewrite_tag('%args%','([^&]+)');
		add_rewrite_tag('%status%','([^&]+)');
		
		add_rewrite_rule(
				'cyber-fundraiser-checkout/(.+)?',
				'index.php?pagename=cyber-fundraiser-checkout&args=$matches[1]',
				'top'
		);
		add_rewrite_rule(
				'cyber-fundraiser-success-donation/(.+)?',
				'index.php?pagename=cyber-fundraiser-success-donation&args=$matches[1]',
				'top'
		);
		add_rewrite_rule(
				'child-project/1?$',
				'index.php?pagename=child-project&status=1',
				'top'
		);
		add_rewrite_rule(
				'child-project/updated?$',
				'index.php?pagename=child-project&status=updated',
				'top'
		);
		add_rewrite_rule(
				'child-project/(.+)?$',
				'index.php?pagename=child-project&args=$matches[1]',
				'top'
		);
		flush_rewrite_rules();
	}
}