<?php

/**
 * Cyber Fundraiser demo data importer
 *
 * @author      Cybersourcepk
 * @category    Admin
 * @package     fundraiser/demo data importer
 * @version     0.1.0
 */

 // Exit if accessed directly
 if ( !defined( 'ABSPATH' ) ) exit;

 // Don't duplicate me!
 if ( !class_exists( 'Cyber_Data_Importer_x' ) ) {

	class Cyber_Data_Importer_x {

		public $add_admin_menu = true;

	    private static $instance;

	    public function __construct() {

	        self::$instance = $this;

	        if( $this->add_admin_menu ) add_action( 'admin_menu', array($this, 'add_admin') );

	    }

	    /*  Add Getting start into admin menu bar */

	    public function add_admin() {

	        add_submenu_page('cyber-fundraiser-settings', "Getting Started", "Getting Started", 'manage_options', 'cyber-fundraising-welcome', array($this, 'intro_html'));

	    }

    	public function intro_html() {

			?>
			
			<div class="wrap">
			
			<h1><strong> <?php _e( 'Welcome to Cyber FundRaiser', 'cyber-fundraiser-lite'); ?></strong></h1>
			<hr class = "cf_stats_line">

	<ol>
		
		<li><?php _e('Collect donations, crowdfund or kick-start your project with Cyber Fundraiser for WordPress.','cyber-fundraiser-lite'); ?></li>
		
		<li><?php _e('Cut out the middle man and put more money into your project.','cyber-fundraiser-lite'); ?></li>
		
		<li><?php _e('Cyber Fundraiser adds just the power-features for simple crowdfunding and quick setup.','cyber-fundraiser-lite'); ?></li>
		
		<li><?php _e('Set a start and end date with a specific goal and wait to take payment until the project is funded, or take donations as they come in.','cyber-fundraiser-lite'); ?></li>
	</ol>
  	
	<h5><?php _e( 'Form more help please visit', 'cyber-fundraiser-lite');?><a href="http://products.cybersourcepk.com/cyber-fundraiser/cf-docs/" > <?php _e( 'Help.', 'cyber-fundraiser-lite');?></a></h5>

	
</div>
<?php }

	} //class

} //function_exists
?>
