<?php
if( ! class_exists( 'WP_List_Table' ) ) {
	require_once( ABSPATH . 'wp-admin/includes/class-wp-list-table.php' );
}
class Cyber_frl_Donation_Table extends WP_List_Table
{
	public function __construct() {
		// Set parent defaults.
		parent::__construct( array(
			'singular' => 'Donation',     // Singular name of the listed records.
			'plural'   => 'Donations',    // Plural name of the listed records.
			'ajax'     => false,       // Does this table support ajax?
		) );
	}
	
	
    /**
     * Prepare the items for the table to process
     *
     * @return Void
     */
    public function prepare_items()
    {
        $columns = $this->get_columns();
        $hidden = $this->get_hidden_columns();
        $sortable = $this->get_sortable_columns();
		$this->process_bulk_action();
		$perPage = $this->get_items_per_page( 'donations_per_page', 10 );
        $currentPage = $this->get_pagenum();
		
		$totalItems = $this->count_data_items();
		$this->set_pagination_args( array(
            'total_items' => $totalItems,
            'per_page'    => $perPage
        ) );
		
		$data_items = $this->get_data_items();
        $data = $this->table_data($data_items);
		
        usort( $data, array( &$this, 'sort_data' ) );
        
        $data = array_slice($data,(($currentPage-1)*$perPage),$perPage);
        $this->_column_headers = array($columns, $hidden, $sortable);
        $this->items = $data;
    }
	public function count_data_items(){
		global $wpdb;
		if(isset($_GET['action']) && $_GET['project']!='all' && $_GET['statuss']=='Both'){
		
			$query = "SELECT *, cfd.id as donationid FROM {$wpdb->prefix}cyber_donations cfd WHERE `project_id`=".sanitize_text_field($_GET['project']);
		

		}elseif(isset($_GET['action']) && $_GET['project']=='all' && $_GET['statuss']!='Both'){
		

			$query = "SELECT *, cfd.id FROM {$wpdb->prefix}cyber_donations cfd WHERE `payment_status`=".sanitize_text_field($_GET['statuss']);
		

		}elseif(isset($_GET['action']) && $_GET['project']!='all' && $_GET['statuss']!='Both'){
			
			$query = "SELECT *, cfd.id as donationids FROM {$wpdb->prefix}cyber_donations cfd WHERE `payment_status`=".sanitize_text_field($_GET['statuss'])." && `project_id`=".sanitize_text_field($_GET['project']);
		
		}elseif(isset($_GET['search_value'])){
			if($_GET['search_value']==''){
				$query = "SELECT *, cfd.id as donationid FROM {$wpdb->prefix}cyber_donations cfd";
			}else{
				$query = "SELECT *, cfd.id FROM {$wpdb->prefix}cyber_donations cfd WHERE `id`=".sanitize_text_field($_GET['search_value'])." || `transaction_id` = ".sanitize_text_field($_GET['search_value']);
			}
		}else{
		
			$query = "SELECT *, cfd.id as donationid FROM {$wpdb->prefix}cyber_donations cfd";
		}
			return count($wpdb->get_results($query));
	}
	
	public function get_data_items(){
		global $wpdb;
		if(isset($_GET['action']) && $_GET['project']!='all' && $_GET['statuss']=='Both'){
		
			$query = "SELECT *, cfd.id as donationid FROM {$wpdb->prefix}cyber_donations cfd WHERE `project_id`=".sanitize_text_field($_GET['project']); /* LIMIT ".$ofset.",".$perPage;*/ 
		

		}elseif(isset($_GET['action']) && $_GET['project']=='all' && $_GET['statuss']!='Both'){
		

			$query = "SELECT *, cfd.id FROM {$wpdb->prefix}cyber_donations cfd WHERE `payment_status`=".sanitize_text_field($_GET['statuss']);/* LIMIT ".$ofset.",".$perPage ;*/
		

		}elseif(isset($_GET['action']) && $_GET['project']!='all' && $_GET['statuss']!='Both'){
			
			$query = "SELECT *, cfd.id as donationids FROM {$wpdb->prefix}cyber_donations cfd WHERE `payment_status`=".sanitize_text_field($_GET['statuss'])." && `project_id`=".sanitize_text_field($_GET['project']);/*  LIMIT ".$ofset.",".$perPage ;*/
		
		}elseif(isset($_GET['search_value'])){
			if($_GET['search_value']==''){
				$query = "SELECT *, cfd.id as donationid FROM {$wpdb->prefix}cyber_donations cfd";
			}else{
				$query = "SELECT *, cfd.id FROM {$wpdb->prefix}cyber_donations cfd WHERE `id`='".sanitize_text_field($_GET['search_value'])."' || `transaction_id` = '".sanitize_text_field($_GET['search_value'])."'";
			}
		}else{
		
			$query = "SELECT *, cfd.id as donationid FROM {$wpdb->prefix}cyber_donations cfd";/* LIMIT ".$ofset.",".$perPage ;*/
		}
			return $wpdb->get_results($query);
	}

    /**
     * Override the parent columns method. Defines the columns to use in your listing table
     *
     * @return Array
     */
    public function get_columns()
    {
        $columns = array(
			'cb'      => '<input type="checkbox" class = "cf_cb_donations" />',
            'id'          => 'ID',
            'name'       => 'Name',
            'payment_method' => 'Payment Method',
            'status'        => 'Status',
            'amount'    => 'Amount',
            'project_name'      => 'Project Name',
			'action'			=> 'Action'
        );
        return $columns;
    }
    /**
     * Define which columns are hidden
     *
     * @return Array
     */
    public function get_hidden_columns()
    {
        return array();
    }
    /**
     * Define the sortable columns
     *
     * @return Array
     */
    public function get_sortable_columns()
    {
		return array(	
						'id'				=> array('id', false)				,
						'name'				=>	array('name',false)				,
						'payment_method'	=>	array('payment_method',false)	,
						'status'			=>	array('status',false)			,
						'amount'			=>	array('amount',false)			,
						'project_name'		=>	array('project_name',false)		,
						'action'			=>	array('action',false)
					);
    }
    /**
     * Get the table data
     *
     * @return Array
     */
    private function table_data($table_data)
    {
		$data = array();
		
		foreach( $table_data as $cf_donation_row ){
			if ( $cf_donation_row->user_id !=''){
				$name = get_user_meta( $cf_donation_row->user_id, 'nickname', true ); 
			}else{
				global $wpdb;
		
				$query = "SELECT * FROM {$wpdb->prefix}cyber_guest_donations WHERE id = ".$cf_donation_row->guest_id;
				$cf_donations_guest_user_info = $wpdb->get_results($query);
				$name = $cf_donations_guest_user_info[0]->fname . " ".  $cf_donations_guest_user_info[0]->lname;
			}
			
			if($cf_donation_row->project_id > 0 ) {
				$project =  '<a href="'.admin_url().'post.php?post='.$cf_donation_row->project_id.'&action=edit">'.get_the_title($cf_donation_row->project_id) .'</a>';
			}else{
					$project =  "<i>Nill</i>";
			}
			$action = '<a class="button cf_view button-primary" href="'. admin_url().'admin.php?page=donations&view=detail&donationid='.$cf_donation_row->id .'">'.__('Project Action','cyber-fundraiser-lite').'</a>';		
			echo $cf_donation_row->fname . $cf_donation_row->lname;
			$record = array(
							'id'         		=> $cf_donation_row->id,
							'name'      	 	=> $name,
							'payment_method'	=> strtoupper(str_replace('_', ' ', $cf_donation_row->paid_via)),
							'status'        	=>  $cf_donation_row->payment_status,
							'amount'    => $cf_donation_row->donation_amount,
							'project_name'      => $project,
							'action'			=> $action
							);
			array_push($data,$record);
		}
        return $data;
    }
    /**
     * Define what data to show on each column of the table
     *
     * @param  Array $item        Data
     * @param  String $column_name - Current column name
     *
     * @return Mixed
     */
    public function column_default( $item, $column_name )
    {
        switch( $column_name ) {
            case 'id':
            case 'name':
            case 'payment_method':
            case 'status':
            case 'amount':
            case 'project_name':
			case 'action':
                return $item[ $column_name ];
            default:
                return print_r( $item, true ) ;
        }
    }
    /**
     * Allows you to sort the data by the variables set in the $_GET
     *
     * @return Mixed
     */
    private function sort_data( $a, $b )
    {
        // Set defaults
        $orderby = 'id';
        $order = 'desc';
        // If orderby is set, use this as the sort column
        if(!empty($_GET['orderby']))
        {
            $orderby = sanitize_text_field($_GET['orderby']);
        }
        // If order is set use this as the order
        if(!empty($_GET['order']))
        {
            $order = sanitize_text_field($_GET['order']);
        }
        $result = strcmp( $a[$orderby], $b[$orderby] );
        if($order === 'asc')
        {
            return $result;
        }
        return -$result;
    }
	public function no_items() {
	  _e( 'No donations avaliable.', 'cyber-fundraiser-lite' );
	}
	
	
	function column_name( $item ) {

	  // create a nonce
	  $delete_nonce = wp_create_nonce( 'cf_delete_donation' );

	  $title = '<strong>' . $item['name'] . '</strong>';

	  $actions = [
		//'delete' => sprintf( '<a href="?page=%s&action=%s&donation=%s&_wpnonce=%s">'.__('Delete', 'cyber-fundraiser-lite').'</a>', esc_attr( $_REQUEST['page'] ), 'delete', absint( $item['id'] ), $delete_nonce )
		'delete' => sprintf( '<span class = "cf_donation_delete_record" href="?page=%s&action=%s&donation=%s&_wpnonce=%s">'.__('Delete', 'cyber-fundraiser-lite').'</span>', esc_attr( $_REQUEST['page'] ), 'delete', absint( $item['id'] ), $delete_nonce )
	  ];

	  return $title . $this->row_actions( $actions );
	}
	
	/**
	 * Delete a donation record.
	 *
	 * @param int $id donation ID
	 */
	public static function delete_donation($id) {
		
		global $wpdb;
		$wpdb->delete(
			"{$wpdb->prefix}cyber_donations",
			[ 'id' =>  absint($id) ],
			[ '%d' ]
		);
	}
	
	/**
	 * Render the bulk edit checkbox
	 *
	 * @param array $item
	 *
	 * @return string
	 */
	function column_cb( $item ) {
	  return sprintf(
		'<input type="checkbox" name="bulk-delete[]" value="%s" />', $item['id']
	  );
	}
	
	/**
	 * Returns an associative array containing the bulk action
	 *
	 * @return array
	 */
	public function get_bulk_actions() {
	  $actions = [
		'bulk-delete' => 'Delete'
	  ];

	  return $actions;
	}

	public function process_bulk_action() {

	  //Detect when a bulk action is being triggered...
	  if ( 'delete' === $this->current_action() ) {

		// In our file that handles the request, verify the nonce.
		$nonce = esc_attr( $_REQUEST['_wpnonce'] );

		if ( ! wp_verify_nonce( $nonce, 'cf_delete_donation' ) ) {
		  die( 'Invalid Nonce' );
		}
		else {
			self::delete_donation(sanitize_text_field($_GET['donation']));
			wp_redirect( $_SERVER['HTTP_REFERER'].'&delete_record='.absint( sanitize_text_field($_GET['donation']) ) );
			exit;
		}

	  }

	  // If the delete bulk action is triggered
	  if ( ( isset( $_POST['action'] ) && $_POST['action'] == 'bulk-delete' )
		   || ( isset( $_POST['action2'] ) && $_POST['action2'] == 'bulk-delete' )
	  ) {

		$delete_ids = esc_sql( $_POST['bulk-delete'] );
		
		// loop over the array of record IDs and delete them
		foreach ( $delete_ids as $id ) {
		  self::delete_donation( $id );
		}
		wp_redirect( $_SERVER['HTTP_REFERER'].'&success=true' );
		exit;
	  }
	}
}