<?php
/**
 * Cyber Fundraiser Admin Menus
 *
 * @author      Cybersourcepk
 * @category    Admin
 * @package     fundraiser/Admin
 * @version     0.1.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

if ( ! class_exists( 'Cyber_frl_Admin_Menus' ) ) :

/**
 * WC_Admin_Menus.
 */

class Cyber_frl_Admin_Menus{


	// The existing settings will be stored here
	public $settings ;
	
	public $donation_obj;

	// saving the created frontend page id here
	public static $frontend_page_id;

	/**
	 * Create Admin pages on load
	 * Enqueue the scripts/styles
	 * Get the settings from options table
	 * @return Array
	 *
	 */

	public function __construct(){
		//setting screen options for donations page
		add_filter( 'set-screen-option',array( $this, 'set_donation_screen' ) , 10, 3 );
		
		//setting screen options for fundraisers page
		add_filter( 'set-screen-option',array( $this, 'set_fundraisers_screen' ) , 10, 3 );
		
		// creating admin menus
		add_action( 'admin_menu', array( $this, 'create_admin_menus' ) ); 

		// enqueue Scripts
		add_action('admin_enqueue_scripts', array($this,'CF_enqueue_admin'),10,1);
		 
		add_action( 'admin_notices', array( $this, 'admin_notices_settings' ) );
		
		// Notice if anyone can register is disabled
		//update_option('dont_show_anyone_can_register_notice', '');
		if ( !get_option( 'users_can_register' ) && !get_option('dont_show_anyone_can_register_notice')) {
			
			add_action( 'admin_notices', array($this,'enable_anyone_can_register' ));
		}
		// get settings on init
		$this->get_settings();

		// Creating Custom Post Types

		$this->register_CF_post_types();

		// Registring Metaboxes

		$this->register_CF_metaboxes();

		//register post type
		$this->get_registered_post_types();


	}
	
	/**
	 * Screen Options for Donation page
	 */
	public static function set_donation_screen( $status, $option, $value ) {
		return $value;
	}
	
	/**
	 * Screen Options for fundraisers page
	 */
	public static function set_fundraisers_screen( $status, $option, $value ) {
		return $value;
	}


	/**
	 * Enqueue Admin Scripts
	 * @return null
	 */

	public function CF_enqueue_admin($hook){
		global $post, $wpdb;	   		  
		if($hook == 'toplevel_page_cyber-fundraiser-settings' || ($hook == 'post.php'  && 'projects' === $post->post_type) || ($hook == 'post-new.php'  && 'projects' === $post->post_type) ||($hook == 'edit.php'  && 'projects' === $post->post_type) || (strpos($hook,"fundraiser")!==false && (strpos($hook,"page_statistics")!==false || strpos($hook,"cyber-fundraising-welcome")!==false || strpos($hook,"page_donations")!==false))){
			wp_enqueue_script('jquery');
			wp_enqueue_style('thickbox');
			wp_enqueue_script('media-upload');
			wp_enqueue_script('thickbox');
			wp_enqueue_media();
			wp_register_script('header-image-upload', CYBER_FRL_ROOT_URL.'/assets/js/admin.js', array('jquery','media-upload','thickbox'));
			wp_enqueue_script('header-image-upload');
			
			// FundRaising admin includes
			wp_enqueue_style( 'wp-color-picker' );
			

			wp_enqueue_style('style-css', CYBER_FRL_ROOT_URL.'/assets/css/admin.css', false, CYBER_FRL_PLUGIN_VERSION );
			wp_enqueue_script('jquery-ui-datepicker');
			wp_enqueue_style('jquery-style', 'http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.2/themes/smoothness/jquery-ui.css');
			wp_enqueue_script( 'admin-script', CYBER_FRL_ROOT_URL. '/assets/js/admin-script.js', array(), '1.0.0', true );
			
			// this for wordpress editor
			wp_enqueue_script('tiny_mce');
			//wp_enqueue_script('my_jquery_ui', "http://code.jquery.com/ui/1.10.3/jquery-ui.js", array('jquery'), '1.0', false);
			wp_enqueue_style( 'bootstrap-style', CYBER_FRL_ROOT_URL. '/assets/css/frontend/bootstrap.min.css' );
			wp_enqueue_script( 'bootstrap-script', CYBER_FRL_ROOT_URL. '/assets/js/frontend/bootstrap.min.js', array(), '1.0.0', true );
		}
		
		
		
			// register & enqueue admin ajax script and other script variables
		$post_id = isset($_GET['post']) ? sanitize_text_field($_GET['post']): '0';
		$cf_settings = get_option( 'cyber_fundraiser_settings' );
		$script_vars = array(
							'ajaxurl'							=> admin_url( 'admin-ajax.php' ),
							'adminurl'							=> admin_url(),
							'post_id'							=> $post_id,
							'cf_settings'						=> $cf_settings,
							'min_project_length_message'		=> __('Your project goal is less than minimum length of project. Minimum length is','cyber-fundraiser-lite'),
							'max_project_length_message'		=> __('Your project goal is greater than maximum length of project. Maximum length is','cyber-fundraiser-lite'),
							'donation_del_confirm_message'		=> __('This Donation Record will be deleted permanently!','cyber-fundraiser-lite'),
							'fundraiser_del_confirm_message'	=> __('This Fundrasier Record will be deleted permanently!','cyber-fundraiser-lite'),
							'recurring_cancel_confirm_message'	=> __('This Recurring will be cancelled permanently!','cyber-fundraiser-lite')
						);
		// script variables for statistics
		if($hook == 'fundraiser_page_statistics'){
			$script_vars['page_hook'] = $hook;
			$visitors_table_name = $wpdb->prefix . 'cyber_statistics_visitors';

			$visits_table_name = $wpdb->prefix . 'cyber_statistics_visits';
			$currentDate = date('Y-m-d');

			$lastWeekDate = date('Y-m-d',strtotime("-1 week"));

			$lastMonthDate = date('Y-m-d',strtotime("-30 days"));

			$lastYearDate = date('Y-m-d',strtotime("-1 year"));

			// retrieving Results from Database
			$uniqueVisitors = $wpdb->get_var( "SELECT COUNT(DISTINCT ip) FROM ". "`".$visitors_table_name."`" );

			$todayVisitors = $wpdb->get_var( "SELECT COUNT( ip) FROM ". "`".$visitors_table_name."`". " where last_counter = "."'".$currentDate."'");

			$lastWeekVisitors = $wpdb->get_var( "SELECT COUNT( ip) FROM ". "`".$visitors_table_name."`". " where last_counter >= "."'".$lastWeekDate."'");

			$lastMonthVisitors = $wpdb->get_var( "SELECT COUNT( ip) FROM ". "`".$visitors_table_name."`". " where last_counter >= "."'".$lastMonthDate."'");

			$lastYearVisitors = $wpdb->get_var( "SELECT COUNT( ip) FROM ". "`".$visitors_table_name."`". " where last_counter >= "."'".$lastYearDate."'");

			$visitorsByCountry = $wpdb->get_results("SELECT `location`, COUNT(`location`) AS `value_occurrence` FROM ". "`".$visitors_table_name."`". " GROUP BY `location` ORDER BY `value_occurrence` DESC limit 5");

			$topVisitedPages = $wpdb->get_results("SELECT `page`, SUM(`visits`) AS `value_occurrence` FROM ". "`".$visits_table_name."`". " GROUP BY `page` ORDER BY `value_occurrence` DESC limit 5");

			$topReferralSites = $wpdb->get_results("SELECT `referred`, COUNT(`referred`) AS `value_occurrence` FROM ". "`".$visitors_table_name."` WHERE `referred`!='' ". " GROUP BY `referred` ORDER BY `value_occurrence` DESC limit 5");

			$topBrowsers = $wpdb->get_results("SELECT `browser_info`, COUNT(`browser_info`) AS `value_occurrence` FROM ". "`".$visitors_table_name."`". " GROUP BY `browser_info` ORDER BY `value_occurrence` DESC limit 5");
			
			$data_for_visitors = array();
								
			array_push($data_for_visitors, $uniqueVisitors);
			
			array_push($data_for_visitors, $todayVisitors);
			
			array_push($data_for_visitors, $lastWeekVisitors);
			
			array_push($data_for_visitors, $lastMonthVisitors);
			
			array_push($data_for_visitors, $lastYearVisitors);
			$script_vars['data_for_visitors'] = $data_for_visitors;
			
			$char='A';
									
			$labels_for_country = array();
			
			$data_for_country = array();
			
			foreach( $visitorsByCountry as $visitorByCountry){
			

			 array_push( $labels_for_country, $char);
			 
			 array_push($data_for_country, $visitorByCountry->value_occurrence);
			 $char++;
			}
			$script_vars['data_for_country'] = $data_for_country;
			$script_vars['labels_for_country'] = $labels_for_country;
			
			$labels_for_referralSites = array();
									
			$data_for_referralSites = array();
			
			foreach( $topReferralSites as $topReferralSite){
				
				array_push($data_for_referralSites, $topReferralSite->value_occurrence);
			}
			$script_vars['data_for_referralSites'] = $data_for_referralSites;
			
			for ($char = 'A'; $char <= 'E'; $char++) {
			
				 array_push( $labels_for_referralSites, $char);
			}
			$script_vars['labels_for_referralSites'] = $labels_for_referralSites;
			
			$labels_for_browserInfo = array();
									
			$data_for_browserInfo = array();
			
			foreach( $topBrowsers as $topBrowser){
				
				array_push($data_for_browserInfo, $topBrowser->value_occurrence);
			}
			$script_vars['data_for_browserInfo'] = $data_for_browserInfo;
			
			for ($char = 'A'; $char <= 'E'; $char++) {
				
				 array_push( $labels_for_browserInfo, $char);
			}
			$script_vars['labels_for_browserInfo'] = $labels_for_browserInfo;
			
			$labels_for_topVisitedPage = array();
			
			$data_for_topVisitedPage = array();
			
			foreach( $topVisitedPages as $topVisitedPage){
				
				array_push($data_for_topVisitedPage, $topVisitedPage->value_occurrence);
			}
			$script_vars['data_for_topVisitedPage'] = $data_for_topVisitedPage;
			
			for ($char = 'A'; $char <= 'E'; $char++) {
			
				 array_push( $labels_for_topVisitedPage, $char);
			}
			$script_vars['labels_for_topVisitedPage'] = $labels_for_topVisitedPage;
		}
		
		wp_register_script( 'handle', admin_url( 'admin-ajax.php' ));

		wp_localize_script( 'handle', 'script_vars', $script_vars );

		wp_enqueue_script( 'handle' );
		
		wp_enqueue_script( 'my-script-handle', CYBER_FRL_ROOT_URL.'/assets/js/cyber-fundraiser-script.js', array( 'wp-color-picker' ), false, true );
	}



	/**
	 * Gettings All Options from options table
	 * @return Array
	 */
	
	public function get_settings(){

		return $this->settings = get_option( 'cyber_fundraiser_settings' );
	}


	/**
	 * Creating Admin Pages
	 * @return string
	 */

	public function create_admin_menus(){

		// Add Fundraiser menu in admin menu bar
		add_menu_page('Fund Raising','Fundraiser Lite','manage_options','cyber-fundraiser-settings',array($this,'cyber_fundraiser_settings_callback'),CYBER_FRL_ROOT_URL.'/assets/images/cyber_fundraiser_icon.png',21);

		// Add sub-menu settings under fundraiser
 		add_submenu_page( 'cyber-fundraiser-settings', 'Settings', 'Settings','manage_options', 'cyber-fundraiser-settings',array($this,'cyber_fundraiser_settings_callback'));

 		// Add sub-menu projects under fundraiser
 		add_submenu_page ( 'cyber-fundraiser-settings', ( 'Projects' ), ( 'Projects' ), 'manage_options', 'edit.php?post_type=projects',NULL);
 		
 		// Add sub-menu Donations under fundraiser
 		$donation_hook = add_submenu_page ( 'cyber-fundraiser-settings', ( 'Donations' ), ( 'Donations' ), 'manage_options', 'donations', array($this, 'cyber_fundraiser_donations_callback'));
		add_action( "load-".$donation_hook, array( $this, 'donation_screen_option' ) );
		add_action( "load-".$donation_hook, array( $this, 'recurring_screen_option' ) );
		}

	/**
	* Screen options
	*/
	public function donation_screen_option() {
		require_once( CYBER_FRL_ROOT_PATH . '/includes/admin/class.admin.donation-table.php' );
		$option = 'per_page';
		$args   = [
			'label'   => 'Donations',
			'default' => 5,
			'option'  => 'donations_per_page'
		];

		add_screen_option( $option, $args );

		$this->donation_obj = new Cyber_frl_Donation_Table();
	}
	
	public function fundraiser_screen_option() {
		require_once( CYBER_FRL_ROOT_PATH . '/includes/admin/class.admin.fundraisers-table.php' );
		$option = 'per_page';
		$args   = [
			'label'   => 'Fundraisers',
			'default' => 5,
			'option'  => 'fundraisers_per_page'
		];

		add_screen_option( $option, $args );

		$this->fundraiser_obj = new Fundrasiers_Table();
	}
	
	public function recurring_screen_option() {
		require_once( CYBER_FRL_ROOT_PATH . '/includes/admin/class.admin.recurring-donations-table.php' );
		$option = 'per_page';
		$args   = [
			'label'   => 'Recurrings',
			'default' => 5,
			'option'  => 'records_per_page'
		];

		add_screen_option( $option, $args );

		$this->recurrings_obj = new Cyber_frl_RecurringDonationsTable();
	}

	/**
	 * Creating CFundraiser Post Types
	 * @return string
	 */

	public function register_CF_post_types(){

		require('class.register.post_types.php');

		$register_projects_post_type = array(
	        
	        "slug" => "projects",
	       
	        "name" => "Projects",
	       
	        "singular_name" => "project",
	        
	        "is_public" => true,
	       
	        "has_archive" => false,
   		 );
     
    	$register_projects_post_type = new Cyber_Fundraiser_Custom_Posts ($register_projects_post_type);
	}

 	/**
    * Returns all registered post types
    */
     public  function get_registered_post_types() {
            $post_types = get_post_types();
            unset($post_types['revision']);
            unset($post_types['attachment']);
            unset($post_types['nav_menu_item']);
            return $post_types;
        }

	/**
	 * Creating CFundraiser Metaboxes
	 * @return string
	 */

	public function register_CF_metaboxes(){

		require('class.admin.metaboxes.php');

     
    	$register_metaboxes = new Cyber_Fundraiser_Metaboxes();
	}



	/**
	 * Settings menu callback
	 * @return string
	 */

	public function cyber_fundraiser_settings_callback(){
		// including the tabs here
		require('views/cyber_fundraiser_cb_view.php');

		// Checking the tab id in URL
		switch( sanitize_text_field($_GET['tab']) ){
			case 'payment':
				$this->payment_settings_tab();
			break;
							
			case 'email':
				$this->email_settings_tab();
			break;

			case 'facebook':
				$this->facebook_settings_tab();
			break;
			
			case 'pages':
				$this->pages_settings_tab();
			break;
			
			default:
				$this->general_settings_tab();
		} 
	}



	/**
	 * Admin Notices
	 * @return null
	 */
	public function admin_notices_settings(){
		if ( ! isset( $_GET['settings_updated'] ) ) {
     		return;
	   	}
	   ?>
	   <div class="updated">

	   		<!-- Setting Success Notice-->
	      <p><b><?php _e('Success ', 'cyber-fundraiser-lite'); ?>!</b> <?php esc_html_e( 'Cyber Fundraiser Settings Updated', 'cyber-fundraiser-lite' ); ?></p>
	   </div>
	   <?php
	  }
	  
	  
	public function enable_anyone_can_register() {
    ?>
		<div class="notice notice-warning is-dismissible anyone_can_register_notice">
			<p><?php _e( 'Thank you for using', 'cyber-fundraiser-lite' ); echo ' <strong>Cyber Fundraiser plugin</strong>.<br>'; _e('Currently Users cannot registered on your site ', 'cyber-fundraiser-lite' ); echo '<strong><a href = "'.home_url().'/wp-admin/options-general.php'.'">'; _e('Click Here', 'cyber-fundraiser-lite' ); echo '</a></strong>'; _e(' to change settings.', 'cyber-fundraiser-lite' ); ?></p>
			<p><a class="button cf_dont_show">Dont Show again.</a></p>
		</div>
    <?php
	}



	/**
	 * Payment Gateways
	 * @return string
	 */

	public function payment_settings_tab(){
	
		// Wait for submittion. If submitted
		if( isset( $_POST['settings']['payment']['submit'] ) ){
			$new_settings  = $_POST['settings'];

			// Sending the Existing and New settings to merge and save settings
			$this->save_settings($this->settings,$new_settings);


			$current_url = "http://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";
			wp_redirect($current_url.'&settings_updated=1');

			 
		}else{
				// Including the HTML for Payment Options
			require('views/cyber_fundraiser_payments_options.php');

			// We have sub tabs for Email
			$payment_settings = isset($_GET['payment_settings']) ? sanitize_text_field($_GET['payment_settings']) : '';

			// Looking for Email sub tab ID

			switch( $payment_settings ){
				case 'bacs':

					// Including the HTML for  BACS settings
					require('views/cyber_fundraiser_payment_bacs_settings.php');
				break;
				
				case 'cheque':
						// Including the HTML for Cheque Settings
					require('views/cyber_fundraiser_payment_cheque_settings.php');
				break;
				
				case 'paypal':
					// Including the HTML for Paypal Settings
					require('views/cyber_fundraiser_payment_paypal_settings.php');
				break;
							
			} 


		}
			
	}





	/**
	 * General Tab Settings
	 * @return string
	 */

	public function general_settings_tab(){

		// Wait for submittion. If submitted
		if( isset( $_POST['settings']['general']['submit'] ) ){
			
			$current_url = "http://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";

			$new_settings  = $_POST['settings'];

			// delete the existing fundraiser roles and update with new ones
			$this->settings['general']['fundraiser_roles'] = '';

			// Sending the Existing and New settings to merge and save settings
			$this->save_settings($this->settings,$new_settings);

			wp_redirect($current_url.'&settings_updated=1');
			 
		}else{
				// Including the HTML for General Settings
			require('views/cyber_fundraiser_general_settings_tab.php');

		}
	}

		public function facebook_settings_tab(){

			require('views/cyber_fundraiser_facebook_settings_tab.php');

	}
	
	/**
	 * Pages Tab Settings
	 * @return string
	 */

	public function pages_settings_tab(){
		

		// Wait for submittion. If submitted
		if( isset( $_POST['settings']['pages']['submit'] ) ){

			$current_url = "http://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";

			$new_settings  = $_POST['settings'];

			// delete the existing fundraiser roles and update with new ones
			$this->settings['general']['fundraiser_roles'] = '';

			// Sending the Existing and New settings to merge and save settings
			$this->save_settings($this->settings,$new_settings);

			wp_redirect($current_url.'&settings_updated=1');
			 
		}else{

				// Including the HTML for pages Settings
			require('views/cyber_fundraiser_pages_settings_tab.php');

		}
	}


	/**
	 * Save Settings
	 *
	 * @param Existing Settings Array
	 * @param New Settings from from submit
	 * @return TRUE if the settings are updated
	 */

	public function save_settings($existing_settings,$new_settings){

		// Recieving the Existing and New settings

		if($existing_settings != '' ): 

		// if settings already exist Merge/replace them with updated settings
			$settings = array_replace_recursive($existing_settings, $new_settings);
		else: 

			// get the posted array only
			$settings = $new_settings;
		endif;

		// Update the database with new settings
		update_option( 'cyber_fundraiser_settings', $settings );

		return true;

	}



	/**
	 * Email Settings
	 * @return string
	 */

	public function email_settings_tab(){

		// Waiting for Form Submit
		if( isset( $_POST['settings']['email']['submit'] ) ){

			$new_settings  = $_POST['settings'];

			$this->save_settings($this->settings,$new_settings);

			$current_url = "http://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";
			wp_redirect($current_url.'&settings_updated=1');
			 
		}else{

			// We have sub tabs for Email
			$email_options = sanitize_text_field($_GET['email_settings']);

			// Looking for Email sub tab ID

			switch( $email_options ){

				// Including HTML for email options settings
				case 'emailoptions':
					require('views/cyber_fundraiser_email_settings_sub_tabs.php');
					require('views/cyber_fundraiser_email_settings_options_tab.php');
				break;
				
				// Including HTML for New Fundraiser email Tab settings
				case 'newfundraiser':
					require('views/cyber_fundraiser_email_settings_sub_tabs.php');
					require('views/cyber_fundraiser_email_settings_new_fundraiser_tab.php');
				break;
				
				// Including HTML for fundraising Completed email Tab settings
				case 'fundraisercompleted':
					require('views/cyber_fundraiser_email_settings_sub_tabs.php');
					require('views/cyber_fundraiser_email_settings_fundraising_complete_tab.php');
				break;
				
				// Including HTML for fundraising pENDING email Tab settings
				case 'fundraiserpending':
					require('views/cyber_fundraiser_email_settings_sub_tabs.php');
					require('views/cyber_fundraiser_email_settings_fundraising_pending_tab.php');
				break;

				default:
					require('views/cyber_fundraiser_email_settings_sub_tabs.php');
					require('views/cyber_fundraiser_email_settings_options_tab.php');
			} 
		}


		
			
	}

	public static function get_page_by_slug($slug) {
		
		// function get_page_by_slug
	    
	    if ($pages = get_pages())
	      
	        foreach ($pages as $page)
	           
	            if ($slug === $page->post_name) return $page;
	   
	    return false;
	} 


	public function cyber_fundraiser_donations_callback()
	{
		// get all the donations records

		global $wpdb;
		if ( isset ($_POST['payment-action'])){
				
	 			$cf_donationid = sanitize_text_field($_POST['donationid']);
	 			
	 			$email_address = sanitize_email($_POST['email_address']);
	 			
	 			$cf_paymentstastus = sanitize_text_field($_POST['payment-status']);
				
				$data = array(  
							
							'donator_name' =>	sanitize_text_field($_POST['donator_name']),
							
							'donation_amount' => sanitize_text_field($_POST['donation_amount']),
							
							'transaction_id' => sanitize_text_field($_POST['transaction_id']),
							
							'paid_via' => sanitize_text_field($_POST['payment_via']), 
							
							'payment_status' => sanitize_text_field($_POST['payment-status']),
							
							'project_id' => sanitize_text_field($_POST['project_id']),
							
							'donation_id' => sanitize_text_field($_POST['donationid']),
						);
						
				if($cf_paymentstastus == 'SendPendingMail'){
					$Send_Email = new Cyber_frl_Send_Email;
						
					$Send_Email-> cyber_fundraiser_send_email($email_address, 'fundraising_pending', 'Fundraiser Pending',$data);
						
					wp_redirect(home_url('wp-admin/admin.php?page=donations'));
				}
				elseif($cf_paymentstastus == 'Pending'){
					
					$update_payment_query = "UPDATE {$wpdb->prefix}cyber_donations Set payment_status = " ."'". $cf_paymentstastus ."'"."Where id = $cf_donationid";
				   
					$updated = $wpdb->query( $update_payment_query);
				  
					if($updated){
						
						 $Send_Email = new Cyber_frl_Send_Email;
						
						 $Send_Email-> cyber_fundraiser_send_email($email_address, 'fundraising_pending', 'Fundraiser Pending',$data);
						$projecDetails = cyber_frl_get_project_detail(sanitize_text_field($_POST['project_id']));
						  update_post_meta(sanitize_text_field($_POST['project_id']), 'total_raised_amount', $projecDetails['amount_raised']);
						  $projecDetails = cyber_frl_get_project_detail(sanitize_text_field($_POST['project_id']));	
							if($projecDetails['status']==='Closed'){
								update_post_meta(sanitize_text_field($_POST['project_id']), 'status', 'Closed');
							}
						wp_redirect(home_url('wp-admin/admin.php?page=donations'));
					}
				}else{
	 			
					$update_payment_query = "UPDATE {$wpdb->prefix}cyber_donations Set payment_status = " ."'". $cf_paymentstastus ."'"."Where id = $cf_donationid";
				   
					$updated = $wpdb->query( $update_payment_query);
				  
					if($updated){
						
						 $Send_Email = new Cyber_frl_Send_Email;
						
						 $Send_Email-> cyber_fundraiser_send_email($email_address, 'fundraising_completed', 'Fundraiser Completed',$data);
						$projecDetails = cyber_frl_get_project_detail(sanitize_text_field($_POST['project_id']));
						  update_post_meta(sanitize_text_field($_POST['project_id']), 'total_raised_amount', $projecDetails['amount_raised']);
						  $projecDetails = cyber_frl_get_project_detail(sanitize_text_field($_POST['project_id']));
						  if($projecDetails['status']==='Closed'){
							update_post_meta(sanitize_text_field($_POST['project_id']), 'status', 'Closed');
						  }
						wp_redirect(home_url('wp-admin/admin.php?page=donations'));
					}
				}
	 	}
	 	if ( isset($_GET['view'])){
	 	
	 		$donationid = sanitize_text_field($_GET['donationid']);
	 	

	 		// Get donation details 
	 		$query = "SELECT *, cfd.id as donationid FROM {$wpdb->prefix}cyber_donations cfd WHERE cfd.id = $donationid ";
	 		
	 		$cf_donations_details = $wpdb->get_results($query);
	 		

	 		// get project details
	 		$cf_donation_project_id = $cf_donations_details[0]->project_id;
	 		
	 		$cf_donation_user_id = $cf_donations_details[0]->user_id;
	 		
	 		$cf_project_detail = get_post( $cf_donation_project_id );
	 		
	 		$cf_project_detail_meta = get_post_meta( $cf_donation_project_id );
	 		

	 		// get the user detail
			if($cf_donations_details[0]->user_id!='')
			{
				$single = false;
			
				$cf_user_details = array_map( function( $a ){ return $a[0]; }, get_user_meta( $cf_donations_details[0]->user_id ) );
				
			}else{
	 		
				$cf_user_id = $cf_donations_details[0]->guest_id;
				
				$query = "SELECT * FROM {$wpdb->prefix}cyber_guest_donations cgd WHERE cgd.id = {$cf_user_id} ";
				

				$results = $wpdb->get_results($query, ARRAY_A);
				
				$cf_user_details = array(
				
					'country' => $results[0]['country'],
				
					'fname' => $results[0]['fname'],
				
					'lname' => $results[0]['lname'],
				
					'comp_name' => $results[0]['comp_name'],
				
					'address' => $results[0]['address'],
				
					'city_name' => $results[0]['city_name'],
				
					'zipcode' => $results[0]['zipcode'],
				
					'email' => $results[0]['email'],
				
					'phone' => $results[0]['phone'],
				);
			}
	 		require('views/cyber_fundraiser_dontions_view_detail.php');
	 	}elseif(sanitize_text_field($_GET['tab']) == 'recurrings'){
			$projects = $wpdb->get_results("SELECT * FROM `{$wpdb->prefix}posts` WHERE `post_type`='projects'&& `post_status`='publish'");
			require('views/cyber_fundraiser_donations_cb_view.php');
			require('views/cyber_fundraiser_recurring_donations_tab.php');
		}else{
			$projects = $wpdb->get_results("SELECT * FROM `{$wpdb->prefix}posts` WHERE `post_type`='projects'&& `post_status`='publish'");
	 		require('views/cyber_fundraiser_donations_cb_view.php');
			require('views/cyber_fundraiser_dontions_view.php');
	 	}
	}

	/**
	* get single row from guest table
	*/
	public function cyber_fundraiser_donations_guest_user( $id )
	{
		global $wpdb;
		
		$query = "SELECT * FROM {$wpdb->prefix}cyber_guest_donations WHERE id = $id";
	 
	 	$cf_donations_guest_user = $wpdb->get_results($query);
	 	return $cf_donations_guest_user;

	}


	/**
	* get single user info
	*/
	public function cyber_fundraiser_donations_login_user( $id )
	{
		
		$single = true;
	  	$user_info = get_user_meta( $id, 'nickname', $single ); 
	  	return $user_info;
	}


	 
	  // function for pagination
	 function pagination($query, $page, $total_query)
	{
		global $wpdb;
		
		$limit =10;
		
		$offset = ($page*$limit)-$limit;
		
		$total_rows=$wpdb->get_var($total_query);
		
		if($total_rows > 0)
		{
			$total = ceil(@($total_rows/$limit));
		}
		else
		{
				 $total = 0;
		}
		
		$query.= " LIMIT ".$offset. " , " .$limit;
		
		$results = $wpdb->get_results($query);
		
		return array($results, $total, $offset);
	}



}

$create_pages = new Cyber_frl_Admin_Menus;

endif;