<?php
if( ! class_exists( 'WP_List_Table' ) ) {
	require_once( ABSPATH . 'wp-admin/includes/class-wp-list-table.php' );
}
class Cyber_frl_RecurringDonationsTable extends WP_List_Table
{
	public function __construct() {
		// Set parent defaults.
		parent::__construct( array(
			'singular' => 'Recurring',     // Singular name of the listed records.
			'plural'   => 'Recurrings',    // Plural name of the listed records.
			'ajax'     => false,       // Does this table support ajax?
		) );
	}
	
	
    /**
     * Prepare the items for the table to process
     *
     * @return Void
     */
    public function prepare_items()
    {
        $columns = $this->get_columns();
		$hidden = $this->get_hidden_columns();
        $sortable = $this->get_sortable_columns();
		$this->process_bulk_action();
		$perPage = $this->get_items_per_page( 'records_per_page', 10 );
        $currentPage = $this->get_pagenum();
		
		$totalItems = $this->count_data_items();
		$this->set_pagination_args( array(
            'total_items' => $totalItems,
            'per_page'    => $perPage
        ) );
		
		$data_items = $this->get_data_items();
        $data = $this->table_data($data_items);
		
        usort( $data, array( &$this, 'sort_data' ) );
        
        $data = array_slice($data,(($currentPage-1)*$perPage),$perPage);
        $this->_column_headers = array($columns, $hidden, $sortable);
        $this->items = $data;
    }
	public function count_data_items(){
		global $wpdb;
		if(isset($_GET['action']) && sanitize_text_field($_GET['project'])!='all' && sanitize_text_field($_GET['statuss'])=='Both'){
			$recurrings = array();
			$temp = cf_get_recurrings();
			foreach($temp as $single_recurring){
				if($single_recurring['project_id'] == sanitize_text_field($_GET['project'])){
					array_push($recurrings, $single_recurring);
				}
			}
		}elseif(isset($_GET['action']) && sanitize_text_field($_GET['project'])=='all' && sanitize_text_field($_GET['statuss'])!='Both'){
			$recurrings = array();
			$temp = cf_get_recurrings();
			foreach($temp as $single_recurring){
				if($single_recurring['status'] == sanitize_text_field($_GET['statuss'])){
					array_push($recurrings, $single_recurring);
				}
			}
		}elseif(isset($_GET['action']) && sanitize_text_field($_GET['project'])!='all' && sanitize_text_field($_GET['statuss'])!='Both'){
			
			$recurrings = array();
			$temp = cf_get_recurrings();
			foreach($temp as $single_recurring){
				if($single_recurring['status'] == sanitize_text_field($_GET['statuss']) && $single_recurring['project_id'] == sanitize_text_field($_GET['project'])){
					array_push($recurrings, $single_recurring);
				}
			}
		
		}elseif(isset($_GET['search_value'])){
			if($_GET['search_value']==''){
				$recurrings = cf_get_recurrings();
			}else{
				$recurrings = cf_get_recurrings(sanitize_text_field($_GET['search_value']));				
			}
		}else{
		
			$recurrings = cf_get_recurrings();
		}
			return count($recurrings);
	}
	
	public function get_data_items(){
		if(isset($_GET['action']) && sanitize_text_field($_GET['project'])!='all' && sanitize_text_field($_GET['statuss'])=='Both'){
		
			$recurrings = array();
			$temp = cf_get_recurrings();
			foreach($temp as $single_recurring){
				if($single_recurring['project_id'] == sanitize_text_field($_GET['project'])){
					array_push($recurrings, $single_recurring);
				}
			}

		}elseif(isset($_GET['action']) && sanitize_text_field($_GET['project'])=='all' && sanitize_text_field($_GET['statuss'])!='Both'){
			
			$recurrings = array();
			$temp = cf_get_recurrings();
			foreach($temp as $single_recurring){
				if($single_recurring['status'] == sanitize_text_field($_GET['statuss'])){
					array_push($recurrings, $single_recurring);
				}
			}
			
		}elseif(isset($_GET['action']) && sanitize_text_field($_GET['project'])!='all' && sanitize_text_field($_GET['statuss'])!='Both'){
			
			$recurrings = array();
			$temp = cf_get_recurrings();
			foreach($temp as $single_recurring){
				if($single_recurring['status'] == sanitize_text_field($_GET['statuss']) && $single_recurring['project_id'] == sanitize_text_field($_GET['project'])){
					array_push($recurrings, $single_recurring);
				}
			}
			
		}elseif(isset($_GET['search_value'])){
			if($_GET['search_value']==''){
				$recurrings = cf_get_recurrings();
			}else{
				$recurrings = cf_get_recurrings(sanitize_text_field($_GET['search_value']));				
			}
		}else{
		
			$recurrings = cf_get_recurrings();
		}
			return $recurrings;
	}

    /**
     * Override the parent columns method. Defines the columns to use in your listing table
     *
     * @return Array
     */
    public function get_columns()
    {
        $columns = array(
			'cb'      => '<input type="checkbox" class = "cf_cb_recurrings" />',
			'customer_id' => 'Customer ID',
            'name'          => 'Name',
            'project_name'       => 'Project',
			'recurring_type'	=> 'Duration',
			'payment_method' => 'Payment Method',
            'created_at' => 'Created At',
            'last_recurring'        => 'Last Recurring',
            'next_recurring'    => 'Next Recurring',
            'total_recurrings'      => 'Total Recurrings',
			'amount'			=> 'Amount',
			'status'			=> 'Status'
        );
        return $columns;
    }
    /**
     * Define which columns are hidden
     *
     * @return Array
     */
    public function get_hidden_columns()
    {
        return array('customer_id');
    }
    /**
     * Define the sortable columns
     *
     * @return Array
     */
    public function get_sortable_columns()
    {
		return array(		
						'name'				=>	array('name',false)				,
						'project_name'      =>	array('project_name',false)		,
						'recurring_type'	=> array('recurring_type',false)	,
						'payment_method'	=>	array('payment_method',false)	,
						'created_at'		=> array('created_at',false)		,
						'last_recurring'    => array('last_recurring',false)	,
						'next_recurring'    => array('next_recurring',false)	,
						'total_recurrings'  => array('total_recurrings',false)	,
						'amount'			=>	array('amount',false)			,
						'status'			=>	array('status',false)			
					);
    }
    /**
     * Get the table data
     *
     * @return Array
     */
    private function table_data($table_data)
    {	
		$data = array();
		foreach( $table_data as $cf_single_recurring ){
			$name = get_user_meta( $cf_single_recurring['user_id'], 'nickname', true ); 
			if($cf_single_recurring['project_id'] > 0 ) {
				$project =  '<a href="'.admin_url().'post.php?post='.$cf_single_recurring['project_id'].'&action=edit">'.get_the_title($cf_single_recurring['project_id']) .'</a>';
			}else{
				$project =  "<i>Nill</i>";
			}
			if($cf_single_recurring['status'] > 0){ 
				$status = __('Active', 'cyber-fundraiser-lite');
				$action = '<a class="button cf_cancel button-primary" href="'. admin_url().'admin.php?page=donations&tab=recurrings&action=cancel&donationid='.$cf_donation_row->id .'">'.__('Cancel','cyber-fundraiser-lite').'</a>';
			}else{ 
				$status = __('Cancelled', 'cyber-fundraiser-lite');
				$action = 'N/A';
			}
			
			$record = array(
							'name'      	 	=> $name,
							'user_id'			=> $cf_single_recurring['user_id'],
							'customer_id'		=> $cf_single_recurring['customer_id'],
							'project_name'      => $project,
							'recurring_type'	=> $cf_single_recurring['donation_type'],
							'payment_method'	=> strtoupper(str_replace('_', ' ', $cf_single_recurring['payment_gateway'])),
							'created_at'		=> date('M-d-Y h:i:s', $cf_single_recurring['first_recurring']),
							'last_recurring'    => date('M-d-Y h:i:s', $cf_single_recurring['last_recurring']),
							'next_recurring'    => date('M-d-Y h:i:s', $cf_single_recurring['renewel_date']),
							'total_recurrings'  => $cf_single_recurring['recurrings'],
							'amount'   			=> $cf_single_recurring['amount'],
							'status'			=> $status
							);
			array_push($data,$record);
		}
        return $data;
    }
    /**
     * Define what data to show on each column of the table
     *
     * @param  Array $item        Data
     * @param  String $column_name - Current column name
     *
     * @return Mixed
     */
    public function column_default( $item, $column_name )
    {
        switch( $column_name ) {
            case 'name':
			case 'project_name':
			case 'recurring_type':
            case 'payment_method':
			case 'created_at':
			case 'last_recurring':
			case 'next_recurring':
			case 'total_recurrings':
            case 'status':
            case 'amount':
                return $item[ $column_name ];
            default:
                return print_r( $item, true ) ;
        }
    }
    /**
     * Allows you to sort the data by the variables set in the $_GET
     *
     * @return Mixed
     */
    private function sort_data( $a, $b )
    {
        // Set defaults
        $orderby = 'id';
        $order = 'desc';
        // If orderby is set, use this as the sort column
        if(!empty($_GET['orderby']))
        {
            $orderby = sanitize_text_field($_GET['orderby']);
        }
        // If order is set use this as the order
        if(!empty($_GET['order']))
        {
            $order = sanitize_text_field($_GET['order']);
        }
        $result = strcmp( $a[$orderby], $b[$orderby] );
        if($order === 'asc')
        {
            return $result;
        }
        return -$result;
    }
	public function no_items() {
	  _e( 'No Recurrings avaliable.', 'cyber-fundraiser-lite' );
	}
	
	
	function column_name( $item ) {

	  // create a nonce
	  $delete_nonce = wp_create_nonce( 'cf_cancel_recurring' );

	  $title = '<strong>' . $item['name'] . '</strong>';

	  $actions = [
		//'delete' => sprintf( '<a href="?page=%s&action=%s&donation=%s&_wpnonce=%s">'.__('Delete', 'cyber-fundraiser-lite').'</a>', esc_attr( $_REQUEST['page'] ), 'delete', absint( $item['id'] ), $delete_nonce )
		'cancel' => sprintf( '<span class = "cf_recurring_cancel" href="?page=%s&tab=%s&action=%s&customer_id=%s&_wpnonce=%s">'.__('Cancel', 'cyber-fundraiser-lite').'</span>', esc_attr( $_REQUEST['page'] ), 'recurrings', 'cancel', $item['customer_id'], $delete_nonce )
	  ];

	  return $title . $this->row_actions( $actions );
	}
	
	/**
	 * Delete a donation record.
	 *
	 * @param int $id donation ID
	 */
	public static function cancel_recurring($customer_id) {
		$users = get_users();
		foreach($users as $user){
			$recurrings = get_user_meta($user->ID,'recurring_donations', true);
			foreach($recurrings as $single_recurring){
				if($single_recurring['customer_id'] == $customer_id){
					$offset = array_search($single_recurring, $recurrings);
					$user_id = $user->ID;
					break;
				}
			}
		}
		$recurrings = cf_get_recurrings($user_id);
		$recurrings[$offset]['status'] = 0;
		update_user_meta($user_id, 'recurring_donations', $recurrings);
		
		$title = get_user_meta( $user_id, 'title', true );
		$firstName = get_user_meta( $user_id, 'fname', true );
		$lastName = get_user_meta( $user_id, 'lname', true );
		
		$data = array(  
			'donator_name' =>	$title." ".$firstName." ".$lastName,
			'donation_amount' => $recurrings[$offset]['amount'],
			'paid_via' => $recurrings[$offset]['payment_gateway'], 
			'recurring_status' => 0,
			'project_id' => $recurrings[$offset]['project_id'],
			'duration'	=> $recurrings[$offset]['donation_type']
		);
		// Send Email
		$Send_Email = new Cyber_frl_Send_Email;
		$Send_Email-> cyber_fundraiser_send_email($emailAddress, 'recurring_cancelled', 'Recurring Cancelled', $data);
	}
	
	/**
	 * Render the bulk edit checkbox
	 *
	 * @param array $item
	 *
	 * @return string
	 */
	function column_cb( $item ) {
	  return sprintf(
		'<input type="checkbox" name="bulk-cancel[]" value="%s" />', $item['customer_id']
	  );
	}
	
	/**
	 * Returns an associative array containing the bulk action
	 *
	 * @return array
	 */
	public function get_bulk_actions() {
	  $actions = [
		'bulk-cancel' => 'Cancel'
	  ];

	  return $actions;
	}

	public function process_bulk_action() {

	  //Detect when a bulk action is being triggered...
	  if ( 'cancel' === $this->current_action() ) {

		// In our file that handles the request, verify the nonce.
		$nonce = esc_attr( $_REQUEST['_wpnonce'] );

		if ( ! wp_verify_nonce( $nonce, 'cf_cancel_recurring' ) ) {
		  die( 'Invalid Nonce' );
		}
		else {
			self::cancel_recurring(sanitize_text_field($_GET['customer_id']));
			wp_redirect( $_SERVER['HTTP_REFERER'].'&success=true' );
			exit;
		}

	  }

	  // If the delete bulk action is triggered
	  if ( ( isset( $_POST['action'] ) && $_POST['action'] == 'bulk-cancel' )
		   || ( isset( $_POST['action2'] ) && $_POST['action2'] == 'bulk-cancel' )
	  ) {
		$cancel_recurrings = esc_sql( $_POST['bulk-cancel'] );
		// loop over the array of record IDs and delete them
		foreach ( $cancel_recurrings as $customer_id ) {
		    self::cancel_recurring( $customer_id );
		}
		wp_redirect( $_SERVER['HTTP_REFERER'].'&success=true' );
		exit;
	  }
	}
}