<?php

defined('ABSPATH') OR exit('No script kidies please.!');

if(!class_exists('Cyber_frl_Site_Statistics'))

{
	class Cyber_frl_Site_Statistics
	{
		private $visitor_ip;
		private $browser_info;
		private $visitor_last_counter;	
		private $visitor_referrer;
		private $visitor_location;
		private $last_visit;
		private $page;
		
		// visits of a page per day per ip
		private $visits;
		
		function __construct()
		{
			add_action('init',array($this, 'save_visitor_info'));
		}
		
		// function for saving visiters data 
		function save_visitor_info()
		{
			global $wpdb;
			
			$visitors_table_name = $wpdb->prefix . 'cyber_statistics_visitors';
			
			$visits_table_name = $wpdb->prefix . 'cyber_statistics_visits';
			
			$page_visited = 'http://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
			
			// Getting the real ip from client
			if (!empty($_SERVER['HTTP_CLIENT_IP']) && array_key_exists('HTTP_CLIENT_IP' , $_SERVER))
				{
					$this->visitor_ip = $_SERVER['HTTP_CLIENT_IP'];
				} 
			
			elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR']) && array_key_exists('HTTP_X_FORWARDED_FOR' , $_SERVER))
			{
					$this->visitor_ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
			}
			
			else 	
			{
					$this->visitor_ip = $_SERVER['REMOTE_ADDR'];
			}
			
			$this->visitor_last_counter = date('Y-m-d');

			$this->last_visit = current_time('mysql');
			

			// geting http reffere of user
			// check to see if request came fromsome site
			// or user sent request from direct url
			
			if( isset($_SERVER['HTTP_REFERER']) && strpos($_SERVER['HTTP_REFERER'], site_url())===false )
			{
				$this->visitor_referrer = $_SERVER['HTTP_REFERER'];	
			}
			else
			{
				//if user requested from direct url
				$this->visitor_referrer='';
			}
			if(strpos($page_visited, admin_url())===false){
				
				// check if visited url is home page
				if($_SERVER['QUERY_STRING']===''){
					
					$this->page = $_SERVER['REQUEST_URI'];
				}
				else{
					
					$this->page = $_SERVER['QUERY_STRING'];
				}
				
				$admin_url = false;
			
			}else
			{
				$admin_url = true;
			}
			
			// getting ip location
			$this->visitor_location = $this->get_ip_location($this->visitor_ip);
			
			// getting correct browser info
			$browser = $this->getBrowser();	
			$this->browser_info = $browser['name']."/".$browser['version'];
			
			// setting value for 'visits' column in cyber_statistics_visits
			$query = "SELECT * FROM ". "`".$visits_table_name."`" ." WHERE 
					  ip = "."'".$this->visitor_ip."'". " && 
					  last_counter = "."'".$this->visitor_last_counter."'"." && 
					  page ="."'".$this->page."'";
			
			if($wpdb->get_row($query))
			{			
				
				$page_already_existed = true;
				
				$this->visits=$wpdb->get_row($query)->visits;
			}
			else
			{
				$page_already_existed = false;
				
				$this->visits = 1;
			}
			

			// Inserting visiter data to database 
			$data_for_visitors_table=array(
					
					'last_counter' => $this->visitor_last_counter,
					
					'referred' => $this->visitor_referrer,
					
					'ip' => $this->visitor_ip,

					'browser_info' =>  $this->browser_info,
					
					'location' => $this->visitor_location
					);
			
			// Inserting visiting information to database 
			$data_for_visits_table = array(
					
					'last_visit' => $this->last_visit,
					
					'last_counter' => $this->visitor_last_counter,
					
					'page' => $this->page,
					
					'ip' => $this->visitor_ip,
					
					'visits' => $this->visits
					);
					
			
			// check either row with this date and ip exist or not
			// if exists then just insert into visit table
			// else insert into both
			
			if($wpdb->get_row("SELECT * FROM `{$visitors_table_name}` WHERE ip = "."'".$this->visitor_ip."'". "&& last_counter = "."'".$this->visitor_last_counter."'"))
			{	
				// check if page url is admin if yes then dont insert
				if(!$admin_url)
				{
					// check if requested method is not GET
					if($_SERVER['REQUEST_METHOD']!='GET')
					{
						// check if $this->visited_page, $this->visitor_last_counter
						// And $this->visitor_ip already exists if so then just update
						// 'visits' column if not then insert new row
						if($page_already_existed)
						{
							$where = array('ip' => $this->visitor_ip, 
									'last_counter' => $this->visitor_last_counter, 
									'page' => $this->page);
						
							$data_for_visits_table=array('visits' =>$this->visits + 1);
						
						
							$wpdb->update( $visits_table_name, $data_for_visits_table, $where );
						}
						else
						{
							$wpdb->insert( $visits_table_name, $data_for_visits_table);
						}
					}
				}
			}
			else
			{
				// check if page url is admin if yes then dont insert
				if(!$admin_url)
				{
					$wpdb->insert($visitors_table_name, $data_for_visitors_table);
					
					$wpdb->insert($visits_table_name, $data_for_visits_table);
				}
			}		
		}
		
		// function for geting location from ip address
		function get_ip_location($ip)
		{
			$details = json_decode(file_get_contents("http://www.geoplugin.net/json.gp?ip={$ip}"));
			
				if(empty($details->geoplugin_countryName)){
					return 'N/A';
				}
				else{
					return $details->geoplugin_countryName;
				}
		}
		
		// function from getting correct browser from HTTP_USER_AGENT
		function getBrowser() 
		{ 
			$u_agent = $_SERVER['HTTP_USER_AGENT']; 
			$bname = 'N/A';
			$platform = 'N/A';
			$version= "";

			//First get the platform?
			if (preg_match('/linux/i', $u_agent)) {
				
				$platform = 'linux';
			}
			elseif (preg_match('/macintosh|mac os x/i', $u_agent)) {
				
				$platform = 'mac';
			}
			elseif (preg_match('/windows|win32/i', $u_agent)) {
				
				$platform = 'windows';
			}
    
			// Next get the name of the useragent yes seperately and for good reason
			if(preg_match('/MSIE/i',$u_agent) && !preg_match('/Opera/i',$u_agent)) 
			{ 
				$bname = 'Internet Explorer'; 
				
				$ub = "MSIE"; 
			} 
			elseif(preg_match('/Firefox/i',$u_agent)) 
			{ 
				$bname = 'Mozilla Firefox'; 
				
				$ub = "Firefox"; 
			} 
			elseif(preg_match('/Chrome/i',$u_agent)) 
			{ 
				$bname = 'Google Chrome'; 
				
				$ub = "Chrome"; 
			} 
			elseif(preg_match('/Safari/i',$u_agent)) 
			{	 
				$bname = 'Apple Safari'; 
				
				$ub = "Safari"; 
			} 
			elseif(preg_match('/Opera/i',$u_agent)) 
			{ 
				$bname = 'Opera'; 
				
				$ub = "Opera"; 
			} 
			elseif(preg_match('/Netscape/i',$u_agent)) 
			{ 
				$bname = 'Netscape'; 
				
				$ub = "Netscape"; 
			} 
    
			// finally get the correct version number
			$known = array('Version', $ub, 'other');
		
			$pattern = '#(?<browser>' . join('|', $known) .
			')[/ ]+(?<version>[0-9.|a-zA-Z.]*)#';
			
			if (!preg_match_all($pattern, $u_agent, $matches)) {
				// we have no matching number just continue
			}
    
			// see how many we have
			$i = count($matches['browser']);
			
			if ($i != 1) {
			
				//we will have two since we are not using 'other' argument yet
				//see if version is before or after the name
				
				if (strripos($u_agent,"Version") < strripos($u_agent,$ub)){
				
					$version= $matches['version'][0];
				}
				else {
				
					$version= $matches['version'][1];
				}
			}
			else {
			
				$version= $matches['version'][0];
			}
    
			// check if we have a number
			
			if ($version==null || $version=="") {$version="?";}
    
			return array(
			
			'userAgent' => $u_agent,
			
			'name'      => $bname,
			
			'version'   => $version,
			
			'platform'  => $platform,
			
			'pattern'    => $pattern
			);
		} 
		
	}
}
?>