<?php 

/**
 * Cyber Fundraiser Register Post Types
 *
 * @author      Cybersourcepk
 * @category    Admin
 * @package     fundraiser/Admin
 * @version     0.1.0
 */

if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly
}

if ( ! class_exists( 'Cyber_Fundraiser_Custom_Posts' ) ) :


/**
 * Cyber_Fundraiser_Custom_Posts.
 */

class Cyber_Fundraiser_Custom_Posts {
 
    function __construct($init) {
 
        $this->settings = $init;

        //count number of project created by current user
        add_action( 'load-post-new.php', array(&$this, 'count_project_post_type') );
       
       //initialize the Project as a post type
        add_action( 'init', array(&$this, 'add_project_post_type') );
      
        //initializing admin notices
        add_action( 'admin_notices', array(&$this,'my_error_notice') );

       
    }
   
    //public $user_post_count;
    function count_project_post_type(){
       
            //get user setting information
            $user_info= get_option( 'cyber_fundraiser_settings' );

          //get current user information
             $current_user = wp_get_current_user();

             //current user role
             $user_role= $current_user->roles;
             $current_role= implode("", $user_role);

             //count no. of post published by current user
            $user_post_count = count_user_posts(  $current_user->ID,"projects");
            
           if($current_role!='administrator'){

                if($user_post_count==1 && $user_info['general']['fundraiser_project_limit']=='off' ){

                      
                     header('Location:'.admin_url().'edit.php?post_type=projects&errors=1'); 

                }
           }
            
    }
   
    // Notice for user if the user has not permission to add more than one project
    function my_error_notice() {
        if(isset($_GET['errors'])){  ?>
     
          <div class="error notice">
             
              <p><?php _e( 'You do not have permission to add more than one project !', 'cyber-fundraiser-lite'); ?></p>
          </div>
          <?php
        }
    }


    // adding project as post-type
    function add_project_post_type(){
     

        $current_user = wp_get_current_user();
      
        $user_role= $current_user->roles;
       
        $current_role= implode("", $user_role);
       
        $user_info= get_option( 'cyber_fundraiser_settings' );

      
        // Allow specific users to add new projects
           if($current_role !='administrator'){

            //check for "add new project" button to show current user or not
              if ( is_array($user_info['general']['fundraiser_roles']) && in_array($current_role, $user_info['general']['fundraiser_roles'])){ 

             /* print_r("I am in"); exit(); */

                 $new_project_button=true; 

                 $capabilities=true;
              }else{    
                
                  $new_project_button=false;
                 
                   $capabilities=false; 
              }
            }else{

              $new_project_button=true; 

              $capabilities=true;

            }
            
            // register project to post-type
            register_post_type( $this->settings['slug'],
                array(
                    'labels' => array(
                        
                        'name' => __( $this->settings['name'] ),
                      
                        'singular_name' => __( $this->settings['singular_name'] ),
                      
                        'add_new'            => _x( 'Add New Project', 'entry data items' ),
                       
                        'add_new_item'       => __( 'Add New Project' ),
                       
                        'edit_item'          => __( 'Edit Project' ),
                       
                        'new_item'           => __( 'New Project' ),
                       
                        'all_items'          => __( 'All Projects' ),
                        
                        'view_item'          => __( 'View Project' ),
                       
                        'search_items'       => __( 'Search Projects' ),
                       
                        'not_found'          => __( 'No Project found' ),
                       
                        'not_found_in_trash' => __( 'No Project found in the Trash' )
                    ),
                   
                    'capability_type'    => 'post',

                     'capabilities'       => array( 'create_posts' => $new_project_button),
                    
                    'map_meta_cap' => $capabilities,

                    'public' => $this->settings['is_public'],
         
                    'has_archive' => $this->settings['has_archive'],

                    'show_in_menu' => false,
                   
                    'show_in_nav_menus' => true,
                    
                    'supports'      => array( 'title', 'editor', 'thumbnail'),
                )
     
        );
     
    }


   
}
endif; ?>
