<?php 

/**
 * Cyber Ajax Functions
 *
 * @author      Cybersourcepk
 * @category    Admin
 * @package     fundraiser/Admin
 * @version     0.1.0
 */

if ( ! defined( 'ABSPATH' ) ) {
   
    exit; // Exit if accessed directly
}

// set default payment method type
add_action( 'wp_ajax_update_default_payment', 'update_default_payment' );

add_action( 'wp_ajax_nopriv_update_default_payment', 'update_default_payment' );
if(!function_exists ( 'update_default_payment' )){
    function update_default_payment() {

        // Handle request then generate response using WP_Ajax_Response
        $cyber_options = get_option( 'cyber_fundraiser_settings' );

        $cyber_options['paymentgateway']['default'] = sanitize_text_field($_POST['data']) ; 

        update_option('cyber_fundraiser_settings',$cyber_options);

        die(0);
    }
}
 // sending Invitation email 
add_action( 'wp_ajax_send_invitation', 'send_invitation' );
add_action( 'wp_ajax_nopriv_send_invitation', 'send_invitation' );
if(!function_exists ( 'send_invitation' )){
    function send_invitation() {
        
        $emails = sanitize_text_field($_POST['data']['emails']);
       
        $email_content = sanitize_text_field($_POST['data']['emailContent']);
    	
        $data['project_id'] = sanitize_text_field($_POST['data']['project_id']);
        
        $email_template = get_option('cyber_fundraiser_settings');
        
        $email_template['email']["invitation"]['content'] = $email_content;


        $Send_Email = new Cyber_frl_Send_Email;

        //send Email now
        $Send_Email-> send_email($emails, 'invitation', 'Invitation From Friend', $email_template, $data);

       
    }
}
     
// Adding project Layout settings 
add_action( 'wp_ajax_update_layout_settings', 'update_layout_settings' );
add_action( 'wp_ajax_nopriv_update_layout_settings', 'update_layout_settings' );
if(!function_exists ( 'update_layout_settings' )){
    function update_layout_settings() {

        $layout_settings = sanitize_text_field($_POST['data']);

        // get layout settings Layout 

        $selected_layout = $layout_settings['project_layout'];


        // serialize the array 

        $serializeData = serialize($layout_settings);

        // we will check if the post id is empty
        // then we will save the settings in options according to post title
        $post_id = sanitize_text_field($_POST['data']['post_id']); 

        
        delete_post_meta($post_id,'project_layout_settings');
       
        update_post_meta($post_id,'project_layout_settings',$serializeData);

        //now update the selected layout
        update_post_meta($post_id,'_cyber_fundraiser_layout',$selected_layout);
        die(0);
    }
}


    // get layout settings with fundrasier block elements settings
if(!function_exists ( 'get_current_blocks' )){
    function get_current_blocks(){

		$layoutSettings = get_post_meta(get_the_ID(),'project_layout_settings',true);


		$unserializedLayoutSettings = unserialize($layoutSettings);

		$existingBlocks = array();

		//left-side layout settings
		if($unserializedLayoutSettings['layoutSettingsLeft']){
			foreach ($unserializedLayoutSettings['layoutSettingsLeft']  as $block) {
			   
				array_push($existingBlocks, trim($block['template']));
			}
		}

		//right-side layout settings
		if($unserializedLayoutSettings['layoutSettingsRight']){
			foreach ($unserializedLayoutSettings['layoutSettingsRight']  as $block) {
			   
				array_push($existingBlocks, trim($block['template']));
			}
		}

		//Main content area settings
		if($unserializedLayoutSettings['layoutSettingsMain']){
			foreach ($unserializedLayoutSettings['layoutSettingsMain']  as $block) {
			   
				array_push($existingBlocks, trim($block['template']));
			}
		}



		return $existingBlocks;

    }
}
//	check if user is loged in or not
add_action('wp_ajax_is_user_logged_in', 'ajax_check_user_logged_in');
add_action('wp_ajax_nopriv_is_user_logged_in', 'ajax_check_user_logged_in');
if(!function_exists ( 'ajax_check_user_logged_in' )){
    function ajax_check_user_logged_in() {
		if(is_user_logged_in()){
			echo 1;
			die();
		}else{
			echo 0;
			die();
		}
    }
}
	
add_action('wp_ajax_dont_show_anyone_can_register_notice', 'ajax_dont_show_anyone_can_register_notice');
add_action('wp_ajax_nopriv_dont_show_anyone_can_register_notice', 'ajax_dont_show_anyone_can_register_notice');
if(!function_exists ( 'ajax_dont_show_anyone_can_register_notice' )){
	function ajax_dont_show_anyone_can_register_notice(){
		update_option('dont_show_anyone_can_register_notice',true);
		die();
	}
}