<?php
defined('ABSPATH') or die('No script kiddies please!');

/**
 * Necessary constants define
 */
if (!defined('CYBER_CSS_DIR')) {
    define('CYBER_CSS_DIR', plugin_dir_url(__FILE__) . '/css');
}
if (!defined('CYBER_IMG_DIR')) {
    define('CYBER_IMG_DIR', plugin_dir_url(__FILE__) . '/images');
}
if (!defined('CYBER_JS_DIR')) {
    define('CYBER_JS_DIR', plugin_dir_url(__FILE__) . '/js');
}
if (!defined('CYBER_VERSION')) {
    define('CYBER_VERSION', '1.2.2');
}
if (!defined('CYBER_TD')) {
    define('CYBER_TD', 'facebook');
}
if (!defined('CYBER_PLUGIN_FILE')) {
    define('CYBER_PLUGIN_FILE', __FILE__);
}

if (!defined('CYBER_API_VERSION')) {
    define('CYBER_API_VERSION', 'v2.0');
}

if (!defined('CYBER_api')) {
    define('CYBER_api', 'https://api.facebook.com/' . CYBER_API_VERSION . '/');
}
if (!defined('CYBER_api_video')) {
    define('CYBER_api_video', 'https://api-video.facebook.com/' . CYBER_API_VERSION . '/');
}

if (!defined('CYBER_api_read')) {
    define('CYBER_api_read', 'https://api-read.facebook.com/' . CYBER_API_VERSION . '/');
}

if (!defined('CYBER_graph')) {
    define('CYBER_graph', 'https://graph.facebook.com/' . CYBER_API_VERSION . '/');
}

if (!defined('CYBER_graph_video')) {
    define('CYBER_graph_video', 'https://graph-video.facebook.com/' . CYBER_API_VERSION . '/');
}
if (!defined('CYBER_www')) {
    define('CYBER_www', 'https://www.facebook.com/' . CYBER_API_VERSION . '/');
}
if (!class_exists('Cyber_frl_Main_Class')) {

    /**
     * Declaration of plugin main class
     * */
    class Cyber_frl_Main_Class {

        var $cyber_fundraiser_facebook_settings;
        var $cyber_extra_settings;

        /**
         * Constructor
         */
        function __construct() {

            $this->cyber_fundraiser_facebook_settings = get_option('cyber_fundraiser_facebook_settings');
            $this->cyber_extra_settings = get_option('cyber_extra_settings');
          
          //action to authorize facebook
            add_action('admin_post_authorize_action', array($this, 'fb_authorize_action')); 
            
            //action to authorize facebook
            add_action('admin_post_cyber_callback_authorize', array($this, 'cyber_callback_authorize')); 

            //action to save settings
            add_action('admin_post_form_action', array($this, 'form_action')); 
           
            // auto post trigger
            add_action('admin_init', array($this, 'auto_post_trigger')); 
            
            //clears log from log table
            add_action('admin_post_cyber_restore_settings', array($this, 'restore_settings')); 

            //saves meta value        
            add_action('save_post', array($this, 'save_cyber_meta_value')); 
       
        }

         /* Returns Default Settings
         */
        function get_default_settings() {
          
            $default_settings = array('auto_publish' => 0,
            
                'application_id' => '',
             
                'application_secret' => '',
              
                'facebook_user_id' => '',
             
                'message_format' => '',
              
                'post_format' => 'simple',
              
                'include_image'=>0,
              
                'post_image' => 'featured',
              
                'custom_image_url' => '',
               
                'auto_post_pages' => array(),
               
                'post_types' => array(),
               
                'category' => array());
            
            return $default_settings;
        }
 
        
        /**
         * Returns all registered post types
         */
        function get_registered_post_types() {
           
            $post_types = get_post_types();
           
            unset($post_types['revision']);
          
            unset($post_types['attachment']);
           
            unset($post_types['nav_menu_item']);
           
            return $post_types;
        }

        /**
         * Action to authorize the facebook
         */
        function fb_authorize_action() {

            if (!empty($_POST) && wp_verify_nonce($_POST['authorize_nonce'], 'authorize_action')) {
             
                include('views/cores/fb-authorization.php');
           
            } else {
             
                die('No script kiddies please');
            }
        }

        /**
         * Facebook Authorize Callback
         */
        function cyber_callback_authorize() {
           
            if (isset($_COOKIE['cyber_session_state']) && isset($_REQUEST['state']) && ($_COOKIE['cyber_session_state'] === $_REQUEST['state'])) {
             
                include('views/cores/fb-authorization-callback.php');
           
            } else {     

                die('No script kiddies please!');
            }
        }

        /**
         * Action to save settings
         */
        function form_action() {
            
            if (!empty($_POST) && wp_verify_nonce($_POST['form_nonce'], 'form_action')) {
            
                include('views/cores/save-settings.php');

            } else {
           
                die('No script kiddies please!!');
           
            }
        }

        /**
         * Auto Post Trigger
         * */
        function auto_post_trigger() {
          
            $post_types = $this->get_registered_post_types();
          
            foreach ($post_types as $post_type) {
             
                $publish_action = 'publish_' . $post_type;
             
                $publish_future_action = 'publish_future_'.$post_type;
             
               add_action($publish_action, array($this, 'auto_post'), 10, 2);
                
            }
        }

        /**
         * Auto Post Action
         * */

        function auto_post($id, $post) {

             $Curent_Fb_id= get_post_meta($post->ID,'facebook-post-id',true);
             
             if(empty($Curent_Fb_id)){

            $auto_post = $_POST['auto_post'];
          
            if ($auto_post == 'yes' || $auto_post == '') {
                
                // facebook api library
                include_once('api/facebook.php'); 
            
                include('views/cores/auto-post.php');
               
                $check = update_post_meta($post->ID, 'auto_post', 'no');
               
             $facebook_post_id= explode("_",$result['id']);

             add_post_meta($post->ID, 'facebook-post-id', $facebook_post_id[1]);
              
                $_POST['auto_post'] = 'no';
            }
          }
        }
        

        /**
         * Saves meta value
         * */
        function save_cyber_meta_value($post_id) {
           
            /*
             * We need to verify this came from the our screen and with proper authorization,
             * because save_post can be triggered at other times.
             */

            // Check if our nonce is set.
            if (!isset($_POST['auto_post']))
                return $post_id;

            $nonce = sanitize_text_field($_POST['cyber_meta_box_nonce_field']);

            // Verify that the nonce is valid.
            if (!wp_verify_nonce($nonce, 'cyber_meta_box_nonce_action'))
                return $post_id;

            // If this is an autosave, our form has not been submitted,
            //     so we don't want to do anything.
            if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE)
                return $post_id;

            // Check the user's permissions.
            if ('page' == sanitize_text_field($_POST['post_type'])) {

                if (!current_user_can('edit_page', $post_id))
                    return $post_id;
            } else {

                if (!current_user_can('edit_post', $post_id))
                    return $post_id;
            }

            /* OK, its safe for us to save the data now. */

            // Sanitize the user input.
            $auto_post = sanitize_text_field($_POST['auto_post']);

            // Update the meta field.
            update_post_meta($post_id, 'auto_post', $auto_post);
        }
        
        /**
         * Restores Default Settings
         */
        function restore_settings(){
          
            $cyber_fundraiser_facebook_settings = $this->get_default_settings();
          
            $cyber_extra_settings = array('authorize_status'=>0);
          
            update_option('cyber_extra_settings', $cyber_extra_settings);
          
            update_option('cyber_fundraiser_facebook_settings', $cyber_fundraiser_facebook_settings);
          
            $_SESSION['cyber_message'] = __('Default Settings Restored Successfully','facebook');
          
           wp_redirect($current_url.'&settings_updated=1');
           
            exit();
        }

    }

    $cyber_obj = new Cyber_frl_Main_Class();
}// class Termination


