<?php
if(!function_exists ( 'cyber_frl_get_project_detail' )){
	function cyber_frl_get_project_detail($project_id = false){
		if(!$project_id){
			$project_id = get_the_ID();
		}
		$tab_setting = get_option( 'cyber_fundraiser_settings' );
		$cf_checkout_slug=$tab_setting['general']['cf_checkout_url'];
		$cf_checkout_slug= preg_replace('{/$}', '', $cf_checkout_slug);
		$cf_child_slug=$tab_setting['general']['cf_child_url'];
		$cf_child_slug= preg_replace('{/$}', '', $cf_child_slug);
		$cf_success_url=$tab_setting['general']['cf_success_url'];
		$cf_success_url= preg_replace('{/$}', '', $cf_success_url);
		
		global $wpdb;
		$project_obj = get_post($project_id); 
		$project_slug = $project_obj->post_name;
		
		$is_child_project = false;
		$parent_project_id = get_post_meta($project_id,'parent-project-id',true);
		$parent_project_obj = get_post($parent_project_id); 
		$parent_project_slug = $parent_project_obj->post_name;
		$donation_table = $wpdb->prefix.'cyber_donations';
		
		$project_start_date  = get_post_meta( $project_id, 'project_start_date', true );
		$project_end_date  = get_post_meta( $project_id, 'project_end_date', true );
		$project_video  = get_post_meta( $project_id, 'project_video_link', true );
		$project_thumbnail_id= get_post_meta($project_id,'_thumbnail_id',true);
		$project_thumbnail_url= wp_get_attachment_thumb_url($project_thumbnail_id);
		
		if(!empty($parent_project_id)){
			$child_project_id = $project_id; 
			$project_id = $parent_project_id;
			$project_status = get_post_meta($child_project_id,'child-project-status',true);
			$is_child_project = true;
			$checkout_url =site_url().'/'.$cf_checkout_slug.'/'.$parent_project_slug.'/'.$project_slug;
			$become_fundraiser_url =  site_url().'/'.$cf_child_slug.'/'.$parent_project_slug;
			$project_goal = get_post_meta ($child_project_id, 'project_goal',true);
			
			// getting donations entries with  completed status
			$total_donated = $wpdb->get_var( $wpdb->prepare( 
				  " SELECT sum(donation_amount) FROM $donation_table WHERE project_id = %d AND payment_status = %s AND child_project_id = %d
				  ", 
				  $project_id,
				  'completed',
				  $child_project_id
				)
			);
			//$project_start_date  = get_post_meta( $child_project_id, 'project_start_date', true );
			//$project_end_date  = get_post_meta( $project_id, 'project_end_date', true );
		}else{
			$dont_receive_donations_after_goal_is_acheived = get_post_meta( $project_id, 'receive_donations_after_goal_is_acheived', true );
				// getting donations entries with  completed status
			$total_donated = $wpdb->get_var( $wpdb->prepare( 
				  " SELECT sum(donation_amount) FROM $donation_table WHERE project_id = %d AND payment_status = %s
				  ", 
				  $project_id,
				  'completed'
				)
			);
			$project_goal = get_post_meta ($project_id, 'project_goal',true);
			if($dont_receive_donations_after_goal_is_acheived && $total_donated >= $project_goal){
				$project_status = 'Closed';
			}
			$checkout_url =site_url().'/cyber-fundraiser-checkout/'.$project_slug;
			$become_fundraiser_url =  site_url().'/'.$cf_child_slug.'/'.$project_slug;
			
			
		}
		
		$return = array(
						'status' 				=> $project_status,
						'is_child_project' 		=> $is_child_project,
						'checkout_url' 			=> $checkout_url,
						'become_fundraiser_url'	=>$become_fundraiser_url,
						'project_goal'			=>$project_goal,
						'project_start_date'	=>$project_start_date,
						'project_end_date'		=>$project_end_date,
						'project_video'			=>$project_video,
						'project_thumbnail_id'	=>$project_thumbnail_id,
						'project_thumbnail_url'	=>$project_thumbnail_url,
						'amount_raised'			=>$total_donated
					);
		return $return;
	}
}


if(!function_exists ( 'cyber_frl_get_project_donations' )){
	function cyber_frl_get_project_donations($project_id=false){
		if(!$project_id){ $project_id=get_the_ID(); }
		
		global $wpdb;
		$table_name1 = $wpdb->prefix . "cyber_donations";
		$table_name2 = $wpdb->prefix . "cyber_guest_donations";
		//$project_details = cyber_frl_get_project_detail($project_id);
		if(cyber_frl_is_child_project($project_id)){
			$parent_project_id = get_post_meta($project_id,'parent-project-id',true);
			$retrieve_data = $wpdb->get_results( "SELECT * FROM $table_name1 WHERE $table_name1.project_id=$parent_project_id AND $table_name1.payment_status='completed' AND $table_name1.child_project_id=$project_id" ); 
			
		} else{
			$retrieve_data = $wpdb->get_results( "SELECT * FROM $table_name1 WHERE $table_name1.project_id=$project_id AND $table_name1.payment_status='completed'" ); 
		//$retrieve_data = $wpdb->get_results( "SELECT * FROM $table_name1 LEFT JOIN  $table_name2 ON $table_name1.guest_id = $table_name2.id  WHERE $table_name1.project_id=$project_id AND $table_name1.payment_status='completed'" ); 
		}
		
		return $retrieve_data;
		
	}
}

if(!function_exists ( 'cyber_frl_get_all_child_projects' )){
	function cyber_frl_get_all_child_projects(){	
		global $wpdb;
		$table_name1 = $wpdb->prefix . "cyber_donations";
		$table_name2 = $wpdb->prefix . "cyber_guest_donations";
		$child_projects = $wpdb->get_results("SELECT `ID`, `post_author`, `post_title`  FROM `".$wpdb->prefix ."posts` LEFT JOIN `".$wpdb->prefix."postmeta` ON `".$wpdb->prefix ."posts`.ID = `".$wpdb->prefix."postmeta`.post_id WHERE `".$wpdb->prefix."postmeta`.meta_key = 'parent-project-id'");
		return $child_projects;
	}
}

if(!function_exists ( 'cyber_frl_get_child_projects' )){
	function cyber_frl_get_child_projects(){
		
		if(!$project_id){ $project_id=get_the_ID(); }
		
		global $wpdb;
		$table_name1 = $wpdb->prefix . "cyber_donations";
		$table_name2 = $wpdb->prefix . "cyber_guest_donations";
		$child_projects = $wpdb->get_results("SELECT `ID`, `post_author`, `post_title`  FROM `".$wpdb->prefix ."posts` LEFT JOIN `".$wpdb->prefix."postmeta` ON `".$wpdb->prefix ."posts`.ID = `".$wpdb->prefix."postmeta`.post_id WHERE `".$wpdb->prefix."postmeta`.meta_key = 'parent-project-id' && `".$wpdb->prefix."postmeta`.meta_value = ".$project_id);
			

		$child_projects_info = array();
		foreach($child_projects as $child_project){
			$child_project_id = $child_project->ID;
			
			$results = $wpdb->get_results("SELECT SUM(`donation_amount`) as donation_amount ,`date_created` FROM $table_name1 WHERE `project_id`=$project_id AND `child_project_id` = $child_project_id AND `payment_status`='completed'");

			$donation_amount = $results[0]->donation_amount;
			$date_created 	= 	$results[0]->date_created;
			$temp_array = array(
								'ID'				=>	$child_project_id,
								'user_id'			=>	$child_project->post_author,
								'post_title'		=>	$child_project->post_title,
								'donation_amount'	=>	$donation_amount,
								'date_created'		=>	$date_created	
								);
			array_push($child_projects_info, $temp_array);
		}

		usort($child_projects_info, 'sortByDonationAmount');
		return $child_projects_info;
	}
}

if(!function_exists ( 'cyber_frl_is_child_project' )){
	function cyber_frl_is_child_project($project_id=false){
		if(!$project_id){ $project_id=get_the_ID(); }
		$parent_project_id = get_post_meta($project_id,'parent-project-id',true);
		 if(!empty($parent_project_id)){ 
			return true;
		 } else{
			return false;
		 }
		
	}
}


if(!function_exists ( 'cyber_frl_show_closed_projects' )){
	function cyber_frl_show_closed_projects(){
		$tab_setting = get_option( 'cyber_fundraiser_settings' );
		$closed_projects=$tab_setting['general']['cf_show_closed_project'];
		if($closed_projects=='' || $closed_projects==1){ 
			return true; 
		}else{
			return false;
		}
	}
}

if(!function_exists ( 'cyber_frl_date_format' )){
	function cyber_frl_date_format(){
		$tab_setting = get_option( 'cyber_fundraiser_settings' );
		if($tab_setting['general']['date_format']==''){
			return 'Y-m-d';
		} else{
			return $tab_setting['general']['date_format'];
		}
	}
}

if(!function_exists ( 'cyber_frl_get_donor_detail' )){
	function cyber_frl_get_donor_detail($donation_id){
		global $wpdb;
		$table_name1 = $wpdb->prefix . "cyber_donations";
		$table_name2 = $wpdb->prefix . "cyber_guest_donations";
		$donation_data = $wpdb->get_results( "SELECT * FROM $table_name1  WHERE `id` = $donation_id" ); 
		
		$donor_id = $donation_data[0]->user_id;
		if(empty($donor_id)){
			$donor_id = $donation_data[0]->guest_id;
			$donor_info = $wpdb->get_results( "SELECT * FROM $table_name2  WHERE `id` = $donor_id" ); 
			$title = $donor_info[0]->title;
			$fname = $donor_info[0]->fname;
			$mnmae = $donor_info[0]->mname;
			$lname = $donor_info[0]->lname;
			$company_name = $donor_info[0]->comp_name;
			$phone = $donor_info[0]->phone;
			$addr = $donor_info[0]->address;
			$city_name =$donor_info[0]->city_name; 
			$zipcode = $donor_info[0]->zipcode;
			$email =  $donor_info[0]->email;
			$country = $donor_info[0]->country;
			$avatar_url= CYBER_FRL_ROOT_URL.'/assets/images/avatar.png';
		}else{
			$table_users=$wpdb->prefix.'users';
			$users_data = $wpdb->get_results('SELECT * FROM '.$table_users.' WHERE ID = '.$donor_id); 
			$user_email = $users_data[0]->user_email;
			
			$title = get_user_meta($donor_id,'title',true);
			$fname = get_user_meta($donor_id,'fname',true);
			$mnmae = get_user_meta($donor_id,'mname',true);
			$lname = get_user_meta($donor_id,'lname',true);
			$company_name = get_user_meta($donor_id,'comp_name',true);
			$phone = get_user_meta($donor_id,'phone',true);
			$addr = get_user_meta($donor_id,'address',true);
			$city_name = get_user_meta($donor_id,'city_name',true);
			$zipcode = get_user_meta($donor_id,'zipcode',true);
			$email =  get_user_meta($donor_id,'email',true);
			$country = get_user_meta($donor_id,'country',true);
			$avatar_url = get_avatar_url($user_email);
			
			$url= site_url().'/wp-admin/profile.php?user_id='.$donor_id;
			$user_url= apply_filters('cf_donor_redirect', $url, $donor_id);
		}
		
		return 	array(
					'title' =>	$title ,
					'fname' => $fname,
					'mnma' => $mnmae,
					'lname' => $lname,
					'company_name' => $company_name,
					'phone' => $phone,
					'addr' => $addr,
					'city_name' => $city_name,
					'zipcode' => $zipcode,
					'email' =>  $email,
					'country' => $country,
					'avatar_url' => $avatar_url,
					'profile_url' => $user_url
				);
		
	}
}

if(!function_exists ( 'cyber_frl_get_project_thumnail_id' )){
	function cyber_frl_get_project_thumnail_id($project_id = false){
		if(!$project_id){
			$project_id = get_the_ID();
		}
		if(!cyber_frl_is_child_project($project_id)){
			$thumbnail_id= get_post_meta($project_id,'_thumbnail_id',true);
		}else{
			//$child_thumbnail_id= get_post_thumbnail_id($post->ID);
			$thumbnail_id= get_post_meta($project_id,'_thumbnail_id',true);
		}
		
		if(empty($thumbnail_id)) {
			return false;
		}else{
			return $thumbnail_id;
		}
	}
}

if(!function_exists ( 'cyber_frl_facebook_settings' )){
	function cyber_frl_facebook_settings(){
		
		$facebook_tab_setting = get_option( 'cyber_fundraiser_facebook_settings' );
		$facebook_user_id= $facebook_tab_setting['facebook_user_id'];
		$facebook_url= "https://www.facebook.com/".$facebook_user_id;
		$facebook_app_id = get_option('cyber_fundraiser_facebook_settings')['application_id'];
		$facebook_user_id = get_option('cyber_fundraiser_facebook_settings')['facebook_user_id']; 
		global $post;
		$fb_post_id= get_post_meta($post->ID, 'facebook-post-id',true);
		$result=array(
						'facebook_user_id'=>$facebook_user_id,
						'facebook_url'=>$facebook_url,
						'facebook_app_id'=>$facebook_app_id,
						'fb_post_id'=>$fb_post_id
						);
		return $result;
	}
}

if(!function_exists ( 'cyber_frl_get_user_dashboard_link' )){
	function cyber_frl_get_user_dashboard_link(){
		$args = array('post_type' => 'page','post_status' => 'publish');
		$pages = get_pages( $args );
		foreach($pages as $page){
			if(strpos($page->post_content, '[my_all_projects]') !== false){
				return $page->post_name;
			}
		}
	}
}

if(!function_exists ( 'cyber_frl_get_payment_gateways_settings' )){
	function cyber_frl_get_payment_gateways_settings(){
		$settings = get_option('cyber_fundraiser_settings');
		return $settings['paymentgateway'];
	}
}

if(!function_exists ( 'cyber_frl_get_email_templates' )){
	function cyber_frl_get_email_templates(){
		$settings = get_option('cyber_fundraiser_settings');
		return $settings['email'];
	}
}

if(!function_exists ( 'cyber_frl_get_general_settings' )){
	function cyber_frl_get_general_settings(){
		$settings = get_option('cyber_fundraiser_settings');
		return $settings['general'];
	}
}

if(!function_exists ( 'cyber_frl_currency_position' )){	
	function cyber_frl_currency_position(){
		 $tab_setting = get_option( 'cyber_fundraiser_settings' );
		 $currency_position = $tab_setting['general']['currency_position'];
		 if($currency_position=='' || $currency_position==0){
			 return "before";
		 } else{
			 return 'after';
		 }
	}
}

if(!function_exists ( 'cyber_frl_get_projects_count' )){
	function cyber_frl_get_projects_count($status){
		$type = "projects";
		$num_posts = wp_count_posts( $type, 'readable' );
		$pending_count = 0;
		if ( !empty($num_posts->$status) )
		  $pending_count = $num_posts->$status;	
		return $pending_count;
	}
}

if(!function_exists ( 'cyber_frl_get_donations_count' )){
	function cyber_frl_get_donations_count($status){
		global $wpdb;
		$table_name = $wpdb->prefix . "cyber_donations";
		$donation_count = $wpdb->get_results( "SELECT count(*) total FROM $table_name  WHERE `payment_status` = '$status'" ); 
		return $donation_count[0]->total; 
	}
}

if(!function_exists ( 'cyber_frl_fudraisers_count' )){
	function cyber_frl_fudraisers_count(){
			 $args = array(
			   'post_type' => 'projects',
			   'post_status'=>'pending',
			   'meta_query' => array(
				   array(
					   'key' => 'parent-project-id',
				   )
			   ),
			   'fields' => 'ids'
			 );
			 // perform the query
			 $project_ids_query = new WP_Query( $args );
			 $project_ids = $project_ids_query->posts;

			 if ( ! empty( $project_ids ) ) {
				 return sizeof($project_ids);
			 }	
	}
}

/*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*/
/*																paypal Functions									*/
/*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*/

// Wrapper methods for all PayPal integration
if(!function_exists ( 'cyber_frl_get_ApiContext' )){
	function cyber_frl_get_ApiContext(){
		require_once CYBER_FRL_ROOT_PATH.'/includes/libraries/PayPal-Rest_api/autoload.php';
		$payment_gateways = cyber_frl_get_payment_gateways_settings();
		$paypal_data = $payment_gateways['paypal'];
		$clientID = $paypal_data['clientID'];
		$clientSecret = $paypal_data['clientSecret'];
		$mode = $paypal_data['sandbox'];
		if(!empty($mode) && $mode=='off'){
			$mode = 'live';
		}else{
			$mode = 'sandbox';
		}
		$apiContext = new \PayPal\Rest\ApiContext(
			new \PayPal\Auth\OAuthTokenCredential(
				$clientID,     // ClientID
				$clientSecret      // ClientSecret
			)
		);
		$apiContext->setConfig(
		  array(
			'mode' => $mode,
			'log.LogEnabled' => true,
			'log.FileName' => 'PayPal.log',
			'log.LogLevel' => 'DEBUG'
		  )
		);
		return $apiContext;
	}
}


/**
 * Create a payment using the buyer's paypal
 * account as the funding instrument. Your app
 * will have to redirect the buyer to the paypal 
 * website, obtain their consent to the payment
 * and subsequently execute the payment using
 * the execute API call. 
 * 
 * @param string $total	payment amount in DDD.DD format
 * @param string $currency	3 letter ISO currency code such as 'USD'
 * @param string $paymentDesc	A description about the payment
 * @param string $returnUrl	The url to which the buyer must be redirected
 * 				to on successful completion of payment
 * @param string $cancelUrl	The url to which the buyer must be redirected
 * 				to if the payment is cancelled
 * @return \PayPal\Api\Payment
 */

if(!function_exists ( 'cyber_frl_makePaymentUsingPayPal' )){
	function cyber_frl_makePaymentUsingPayPal($total, $currency, $paymentDesc, $returnUrl, $cancelUrl) {
		require_once CYBER_FRL_ROOT_PATH.'/includes/libraries/PayPal-Rest_api/autoload.php';
		$payer = new PayPal\Api\Payer();
		$payer->setPaymentMethod("paypal");
		
		// Specify the payment amount.
		$amount = new PayPal\Api\Amount();
		$amount->setCurrency($currency);
		$amount->setTotal($total);
		
		// ###Transaction
		// A transaction defines the contract of a
		// payment - what is the payment for and who
		// is fulfilling it. Transaction is created with
		// a `Payee` and `Amount` types
		$transaction = new PayPal\Api\Transaction();
		$transaction->setAmount($amount);
		$transaction->setDescription($paymentDesc);
		
		$redirectUrls = new PayPal\Api\RedirectUrls();
		$redirectUrls->setReturnUrl($returnUrl);
		$redirectUrls->setCancelUrl($cancelUrl);
		
		$payment = new PayPal\Api\Payment();
		$payment->setRedirectUrls($redirectUrls);
		$payment->setIntent("sale");
		$payment->setPayer($payer);
		$payment->setTransactions(array($transaction));
		
		$payment->create(cyber_frl_get_ApiContext());
	  return $payment->getApprovalLink();;
	  //return $payment->getId();
	}
}


/**
 * Completes the payment once buyer approval has been
 * obtained. Used only when the payment method is 'paypal'
 * 
 * @param string $paymentId id of a previously created
 * 		payment that has its payment method set to 'paypal'
 * 		and has been approved by the buyer.
 * 
 * @param string $payerId PayerId as returned by PayPal post
 * 		buyer approval.
 */
if(!function_exists ( 'cyber_frl_executePayment' )){
	function cyber_frl_executePayment($paymentId, $payerId) {
		require_once CYBER_FRL_ROOT_PATH.'/includes/libraries/PayPal-Rest_api/autoload.php';
		$payment = cyber_frl_getPaymentDetails($paymentId);
		$paymentExecution = new PayPal\Api\PaymentExecution();
		$paymentExecution->setPayerId($payerId);	
		$payment = $payment->execute($paymentExecution, cyber_frl_get_ApiContext());	
		
		return $payment;
	}
}
/**
 * Retrieves the payment information based on PaymentID from Paypal APIs
 *
 * @param $paymentId
 *
 * @return Payment
 */

if(!function_exists ( 'cyber_frl_getPaymentDetails' )){
	function cyber_frl_getPaymentDetails($paymentId) {
		require_once CYBER_FRL_ROOT_PATH.'/includes/libraries/PayPal-Rest_api/autoload.php';
		$payment = PayPal\Api\Payment::get($paymentId, cyber_frl_get_ApiContext());
		return $payment;
	}
}

if(!function_exists ( 'cyber_frl_PPHttpPost' )){
	function cyber_frl_PPHttpPost($methodName_, $nvpStr_, $PayPalApiUsername, $PayPalApiPassword, $PayPalApiSignature, $PayPalMode) {
        // Set up your API credentials, PayPal end point, and API version.
        $API_UserName = urlencode($PayPalApiUsername);
        $API_Password = urlencode($PayPalApiPassword);
        $API_Signature = urlencode($PayPalApiSignature);

        $paypalmode = ($PayPalMode=='sandbox') ? '.sandbox' : '';

        $API_Endpoint = "https://api-3t".$paypalmode.".paypal.com/nvp";
        $version = urlencode('109.0');

        // Set the curl parameters.
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $API_Endpoint);
        curl_setopt($ch, CURLOPT_VERBOSE, 1);

        // Turn off the server and peer verification (TrustManager Concept).
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);

        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 0);
        curl_setopt ($ch, CURLOPT_CAINFO, dirname(__FILE__) . "/cacert.pem");

        // Set the API operation, version, and API signature in the request.
        $nvpreq = "METHOD=$methodName_&VERSION=$version&PWD=$API_Password&USER=$API_UserName&SIGNATURE=$API_Signature$nvpStr_";

        // Set the request as a POST FIELD for curl.
        curl_setopt($ch, CURLOPT_POSTFIELDS, $nvpreq);

        // Get response from the server.
        $httpResponse = curl_exec($ch);

        if(!$httpResponse) {
            exit("$methodName_ failed: ".curl_error($ch).'('.curl_errno($ch).')');
        }

        // Extract the response details.
        $httpResponseAr = explode("&", $httpResponse);

        $httpParsedResponseAr = array();
        foreach ($httpResponseAr as $i => $value) {
            $tmpAr = explode("=", $value);
            if(sizeof($tmpAr) > 1) {
                $httpParsedResponseAr[$tmpAr[0]] = $tmpAr[1];
            }
        }

        if((0 == sizeof($httpParsedResponseAr)) || !array_key_exists('ACK', $httpParsedResponseAr)) {
            exit("Invalid HTTP Response for POST request($nvpreq) to $API_Endpoint.");
        }

        return $httpParsedResponseAr;
    }
}
	
/*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*/
/*												End paypal Functions												*/
/*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*/
?>