<?php
defined('ABSPATH') or die('No script kiddies please!');
    $id = $post->ID;
	$parent_project_id = get_post_meta($id, 'parent-project-id',true);
    $account_details = get_option('cyber_fundraiser_facebook_settings') ? get_option('cyber_fundraiser_facebook_settings'): array();

    $account_extra_details = get_option('cyber_extra_settings');
    $post_type = get_post_type($id);
    $taxonomies = get_object_taxonomies($post_type);
    $terms = wp_get_post_terms($id, $taxonomies);
    $categories = isset($account_details['category']) ? $account_details['category'] : array();
   
    $category_flag = false;
    if (count($categories) == 0) {
        $category_flag = true;
    } else if (in_array('all', $categories)) {
        $category_flag = true;
    } else {
        foreach ($terms as $term) {
            if (in_array($term->term_id, $categories)) {
                $category_flag = true;
            }
        }
    }
    
    /**
     * Checking if the post type of this post is enabled in the account settings and the account is already authorized
     *  in facebook
     * */
    if (in_array($post_type, $account_details['post_types']) && $account_extra_details['authorize_status'] == 1 && $category_flag) {
        
        foreach ($account_details as $key => $val) {
            $$key = $val;
        }

        foreach ($account_extra_details as $key => $val) {
            $$key = $val;
        }

        $post_title = $post->post_title;
        $post_content = strip_tags($post->post_content);
        $post_content = str_replace('&nbsp;','',$post_content);
        $post_content = strip_shortcodes($post_content);
        $post_excerpt = $post->post_excerpt;
        $project_goal=sanitize_text_field($_POST['project_goal']);
		if(empty($project_goal)){
		  $project_goal= get_post_meta($id,'project_goal', true);
		}
        $project_start_date= sanitize_text_field($_POST['project_start_date']);
        if(empty($project_start_date)){
		  $project_start_date= get_post_meta($id,'project_start_date', true);
		}
		$project_end_date=sanitize_text_field($_POST['project_end_date']);
        if(empty($project_end_date)){
		  $project_end_date= get_post_meta($id,'project_end_date', true);
		}
		$post_link = get_the_permalink($id);
        $post_author_id = $post->post_author;
        $caption = get_bloginfo('description');
        $author_name = get_the_author_meta('user_nicename', $post_author_id);
        $message_format = str_replace('#post_title', $post_title, $message_format);
        $message_format = str_replace('#post_content', $post_content, $message_format);
        $message_format = str_replace('#post_excerpt', $post_excerpt, $message_format);
        $message_format = str_replace('#post_link', $post_link, $message_format);
        $message_format = str_replace('#author_name', $author_name, $message_format);
        $message_format = str_replace('#project_goal', $project_goal, $message_format);
        $message_format = str_replace('#project_start_date', $project_start_date, $message_format);
        $message_format = str_replace('#project_end_date', $project_end_date, $message_format);

        if (is_array($auto_post_pages) && !empty($auto_post_pages)) {
            foreach ($auto_post_pages as $auto_publish_page) {
                if ($auto_publish_page != 1) {
                    $access_token = $pages[$auto_publish_page]->access_token;
                    $page_id = $auto_publish_page;
                    $page_name = $pages[$auto_publish_page]->name;
                } else {
                    $page_id = '';
                    $page_name = 'Profile Page';
                }
              
                $fb = new FBAPFacebook(array(
                    'appId' => $access_token,
                    'secret' => $application_secret,
                    'cookie' => true
                ));
               
                if ($post_format == 'simple') {  //For Simple Text Message Posting
                    $attachment = array('message' => $message_format,
                        'access_token' => $access_token);
                } else {  //For attaching the blog post along with the text message
                    if ($post_image == 'featured_image') {
                        
                        if (has_post_thumbnail($id)) {

                            $image_id = get_post_thumbnail_id($id);
                            $image_url = wp_get_attachment_image_src($image_id, 'large', true);
                            $picture = $image_url[0];
                        }elseif(!empty($parent_project_id)){
							$image_id = get_post_thumbnail_id($parent_project_id);
                            $image_url = wp_get_attachment_image_src($image_id, 'large', true);
                            $picture = $image_url[0];
						} else {
                            $picture = trim($custom_image_url);
                        }
                    } else {
                        $picture = trim($custom_image_url);
                    }
                    $attachment = array('message' => $message_format,
                        'access_token' => $access_token,
                        'link' => $post_link,
                        'name' => $post_title,
                        'caption' => $caption,
                        'description' => $post_content,
                        'actions' => array(array('name' => $post_title,
                                'link' => $post_link)),
                        'picture' => $picture
                    );
                }
                $post_id = $id;
                $log_time = date('Y-m-d h:i:s A');
               
                try {

                    $result = $fb->api('/' . $page_id . '/feed/', 'post', $attachment);
                    //var_dump($result);
                    /**
                     * Logged as success
                     * */
                    $log_status = 1;
                    $log_details = __('Posted Successfully on ', 'facebook') . $page_name;
                } catch (Exception $e) {
                    /**
                     * Logged as failure
                     * */
                    
                    $error_message = $e->getMessage();
                    $log_status = 0;
                    $log_details = $error_message;
                }
            } //foreach auto publish pages
        } //If autopublish page is not empty check closed
    }

    