<?php
/**
 *
 *
 *
 */

if( !class_exists( 'Cyber_frl_Send_Email' ) ){
	class Cyber_frl_Send_Email{
		
		public function __construct(){
			add_filter ('wp_mail_content_type',array( &$this, 'cyber_fundraiser_mail_content_type'));
		}
		
		public function cyber_fundraiser_mail_content_type(){
			return "text/html";
		}
		
		public function cyber_fundraiser_send_email($emails, $email_type, $email_subject, $data) {

			$email_template = get_option('cyber_fundraiser_settings');
			switch ( $email_type ){
				case 'new_fundraising' :

					$this->send_email($emails, $email_type, $email_subject, $email_template, $data );
				break;
				
				case 'fundraising_completed' :
					
					$this->send_email($emails, $email_type, $email_subject, $email_template,$data );
					
				break;
				
				case 'fundraising_pending' :
					
					$this->send_email($emails, $email_type, $email_subject, $email_template,$data );
					
				break;
				
				case 'new_become_fundraiser' :
					
					$this->send_email($emails, $email_type, $email_subject, $email_template,$data );
					
				break;
				
				case 'become_fundraiser_approval' :
					
					$this->send_email($emails, $email_type, $email_subject, $email_template,$data );
					
				break;
				
				case 'become_fundraiser_rejected' :
					
					$this->send_email($emails, $email_type, $email_subject, $email_template,$data );
					
				break;
				
				case 'become_fundraiser_closed' :
					
					$this->send_email($emails, $email_type, $email_subject, $email_template,$data );
					
				break;
				
				case 'new_recurring' :
					
					$this->send_email($emails, $email_type, $email_subject, $email_template, $data );
				break;
				
				case 'recurring_successful' :
					
					$this->send_email($emails, $email_type, $email_subject, $email_template, $data );
				break;
				
				case 'recurring_failed' :
					
					$this->send_email($emails, $email_type, $email_subject, $email_template, $data );
				break;
				
				case 'recurring_cancelled' :
					
					$this->send_email($emails, $email_type, $email_subject, $email_template, $data );
				break;
				
				default :
				
					$this->send_email($emails ,  $email_template, $data );
			}
		}
		
		public function send_email($emails, $email_type, $email_subject, $email_template, $data ){
			

			// send email type to template to load the content from the db according to email type
			if($email_type == 'new_fundraising')
				$email_type = 'new-fundraising';

			if($email_type == 'fundraising_completed')
				$email_type = 'fundraisingcompleted-content';
			
			if($email_type == 'fundraising_pending')
				$email_type = 'fundraisingpending-content';
			
			if($email_type == 'new_become_fundraiser')
				$email_type = 'new-become-fundraiser';
			
			if($email_type == 'become_fundraiser_approval')
				$email_type = 'become-fundraiser-approved';
			
			if($email_type == 'become_fundraiser_rejected')
				$email_type = 'become-fundraiser-rejected';
			
			if($email_type == 'become_fundraiser_closed')
				$email_type = 'become-fundraiser-closed';

			if($email_type == 'new_recurring')
				$email_type = 'new-recurring';
			
			if($email_type == 'recurring_successful')
				$email_type = 'recurring-successful';
			
			if($email_type == 'recurring_failed')
				$email_type = 'recurring-failed';
	
			if($email_type == 'recurring_cancelled')
				$email_type = 'recurring-cancelled';


			// explode emails here
			$emailsArray = explode(',', $emails);
			
			foreach ($emailsArray as $email ) {
		
				ob_start();
			
				require('views/fundraiser_email_template.php');
				
				$email_template_result = ob_get_contents();
				
				if(($data['paid_via'] == 'Direct Bank Transfer'||$data['paid_via'] =='Cheque Payment') && $email_type == 'new-fundraising')
				{
					
					$status_note = "<strong>Note: </strong><li> You have make donation via {$data['paid_via']}, yout payment statuss is pending, to complete your donation send us transaction_id along with your donation id. Thanks. </li>";
					
					$email_template_result = str_replace('<p id = "status"></p>', $status_note ,$email_template_result );
				}
				if(!empty($data['project_id']) && $data['project_id'] < 1)
				{
					
					$project_note= "<li>You have donated directly to {$_SERVER['HTTP_HOST']}, not to specific project therefore Project Title and Project link are blank.</li>";
					
					$email_template_result = str_replace('<p id = "note"></p>', $project_note ,$email_template_result );
				}
				if($data['recurring_status'] < 1){
					$recurring_status = 'Cancelled';
				}else{
					$recurring_status = 'Active';
				}
				
				if($data['parent_project_id'] < 1 || $data['parent_project_id'] == ''){
					$parent_project_link = '';
					$parent_project_title = '';
				}else{
					$parent_project_link = get_permalink($data['parent_project_id']);
					$parent_project_title = get_the_title ($data['parent_project_id']);
				}
				
				$email_shorttags = array(	'{project-name}'					,
											'{project-link}'					,
											'{donor-name}'						,
											'{amount}'							,
											'{donation_id}'						,
											'{transaction-id}'					,
											'{payment-type}'					,
											'{payment-status}'					,
											'{parent-project-name}'				,		
											'{parent-project-link}'				,
											'{become-fundraiser-name}'			,
											'{become-fundraiser-goal}'			,
											'{become-fundraiser-collection}'	,
											'{new-become-fundraiser-message}'	,
											'{recurring-status}'				,
											'{duration}'						,
											'{recurring-time}'					,
											'{next-recurring}'					,
											'{cancel-recurring-link}'
											); 
				
				$replaced_text = array(
										get_the_title ($data['project_id'])			,
										get_permalink($data['project_id'])			,
										$data['donator_name']						,
										$data['donation_amount']					,
										$data['donation_id']						,
										$data['transaction_id']						,
										$data['paid_via']							,
										$data['payment_status']						,
										$parent_project_title						,
										$parent_project_link						,
										$data['become_fundraiser_name']				, 
										$data['become_fundraiser_goal']				,
										$data['become_fundraiser_collection']		,
										$data['become_fundraiser_message']			,
										$recurring_status							,
										$data['duration']							,
										$data['recuring_time']						,
										$data['next_recurring']						,
										home_url().'/'.cyber_frl_get_user_dashboard_link()
										);
				
				$email_template_result = str_replace($email_shorttags, $replaced_text ,$email_template_result );
				wp_mail($email, $email_subject, $email_template_result);
				ob_end_clean();
				

			}
		}
	}	
}

?>