<?php
if(!class_exists('Cyber_Fundraiser_layout')){
	class Cyber_Fundraiser_layout {

		public function __construct() {
			add_filter('single_template', array($this,'get_custom_post_type_template' ));

			//enqueue layout CSS/jS
			add_action( 'wp_enqueue_scripts', array($this,'cyber_fundraiser_frontend_scripts' ) );

		}

		public function get_custom_post_type_template($template) {
			 global $post;
			 if ($post->post_type == 'projects') {
				 
				 if(file_exists(get_template_directory()."/cyber-fundraiser/cyber_projects_frontend_default.php")){
			
				$template = get_template_directory(). '/cyber-fundraiser/cyber_projects_frontend_default.php';
			

			} else if(file_exists(CYBER_FRL_ROOT_PATH. '/includes/frontend/templates/cyber_projects_frontend_default.php')){
				
				$template = CYBER_FRL_ROOT_PATH. '/includes/frontend/templates/cyber_projects_frontend_default.php';
			
				}
			
			 }
			 return $template;
		}

		/**
		 * Proper way to enqueue scripts and styles.
		 */
		public function cyber_fundraiser_frontend_scripts() {
			
			global $post, $wp_query, $wpdb;
			
			wp_enqueue_style( 'cyber-fundraising-style', CYBER_FRL_ROOT_URL. '/assets/css/frontend/cyber-fundraising.css' );
		  
			wp_enqueue_style( 'cyber-fundraising-project-countdown-css', CYBER_FRL_ROOT_URL. '/assets/css/jquery.countdownTimer.css' );
		  
			wp_enqueue_script( 'cyber-fundraising-countdownTimer', CYBER_FRL_ROOT_URL. '/assets/js/frontend/jquery.countdownTimer.min.js', array('jquery'), '1.0.0', true  );
			
			wp_register_script( 'cyber-fundraising-frontend-script', CYBER_FRL_ROOT_URL. '/assets/js/frontend/cyber-fundraiser-frontend-script.js', array('jquery'), '1.0.0', true);
			$script_vars = array(
								'ajaxurl' 				=> admin_url( 'admin-ajax.php' ),
								'home_url' 				=> home_url(),
								'cf_settings'			=> get_option( 'cyber_fundraiser_settings' ),
								'postContent' 			=> $post->post_content,
								'postType' 				=> $post->post_type,
								'session'				=> $_SESSION
							);
			if('projects' === $post->post_type){
				$project_details=cyber_frl_get_project_detail(get_the_ID());
				
				$date1 = new DateTime(get_post_meta(get_the_ID() ,'project_start_date',true));
		   
				$date2 = new DateTime(get_post_meta(get_the_ID() ,'project_end_date',true));
			
				$start_date = $date1->format('Y/m/d H:i:s');
				$project_status = get_post_meta($child_project_id,'child-project-status',true);
				$project_end_date = $date2->format('Y/m/d H:i:s');
				$script_vars['countDownStartDate'] = date('Y/m/d H:i:s');
				$script_vars['countDownDateAndTime'] = $project_end_date;
				$script_vars['post_author'] = $post->post_author;
				
				$script_vars['project_closed'] = __('Project Closed', 'cyber-fundraiser-lite');
				//$script_vars['donate_button_model_message'] = __('You cannot donate because this project has been '.$project_status, 'cyber-fundraiser-lite');
				$script_vars['donate_button_model_message'] = __('Thank you for your interest in this project, but We are really sorry for not accepting your donation because the Project which you selected has been '.$project_details['status'].'. So if you want to donate then please take a look on our active projects or you can also donate to this organization.', 'cyber-fundraiser-lite');
				$script_vars['become_fundraiser_button_model_message'] = __('You cannot become a fundraiser of this project, because this project has been '.$project_details['status'].'.', 'cyber-fundraiser-lite');
				
				
			}elseif($post->post_type == 'page' && strpos($post->post_content, '[cyber_become_fundraiser]') !== false){
				if(isset($wp_query->query['status'])){
					$script_vars['status'] = $wp_query->query['status'];
				}
				if(isset($wp_query->query['args']) && $wp_query->query['args'] != ''){
					$args = explode("/",$wp_query->query['args']);
					if(count($args) > 1){
						
						$post = get_page_by_path( $args[0], OBJECT, 'projects' );
						if(!empty($post->ID)){
							$script_vars['child_project_id'] = $post->ID;
						}else{
							echo '<p> Project does not exists.</p>';
							exit;
						}
						$script_vars['child_project_action'] = $args[1];
					}else{
						
						$post = get_page_by_path( $args[0], OBJECT, 'projects' );
						if(!empty($post->ID)){
							$parent_project_id = $post->ID;
							$script_vars['project_id'] = $post->ID;
						}else{
							echo '<p> Project does not exists.</p>';
							exit;
						}
					}
				}
			}elseif($post->post_type == 'page' && strpos($post->post_content, '[cyber_checkout]') !== false){
				cyber_frl_StartSession();
				$args = explode("/",$wp_query->query['args']);
				if(!empty($args[0])){
					$post = get_page_by_path( $args[0], OBJECT, 'projects' );
					if(!empty($post->ID)){
						$project_id=$post->ID;
					}else{
						$project_id=0;
					}
				}else{
					$project_id=0;
				}
				$script_vars['project_id'] = $project_id;
				
				if(!empty($args[1])){
					$post = get_page_by_path( $args[1], OBJECT, 'projects' );
					if(!empty($post->ID)){
						$child_project_id=$post->ID;
					}else{
						$child_project_id=0;
					}	
				}else{
					$child_project_id=0;
				}
				$script_vars['child_project_id'] = $child_project_id;
				
				$donation_table = $wpdb->prefix.'cyber_donations';
				// getting donations entries with  completed status
				$total_donated = $wpdb->get_var( $wpdb->prepare( 
				  " SELECT sum(donation_amount) FROM $donation_table WHERE project_id = %d AND payment_status = %s
				  ", 
				  $project_id,
				  'completed'
				) );

				$project_goal = get_post_meta ($project_id, 'project_goal',true);
				$remaining_goal = $project_goal - $total_donated;
				$receive_donations_after_goal_is_acheived = get_post_meta( $project_id, 'receive_donations_after_goal_is_acheived', true );
				
				$script_vars['project_goal'] = $project_goal;
				$script_vars['remaining_goal'] = $remaining_goal;
				$script_vars['receive_donations_after_goal_is_acheived'] = $receive_donations_after_goal_is_acheived;
				$currency = $script_vars['cf_settings']['general']['currency'];
				if(empty($currency)){
					$currency = 'USD';
				}
				$script_vars['currency'] = $currency;
				$script_vars['user_meta'] = get_user_meta(get_current_user_id());
				$script_vars['configuration_error_message_1'] = __('Direct Bank Transfer payment method is not fully configured choose some other payment method.', 'cyber-fundraiser-lite');
				$script_vars['configuration_error_message_2'] = __('Stripe payment method is not fully configured choose some other payment method.', 'cyber-fundraiser-lite');
				$script_vars['configuration_error_message_3'] = __('Braintree payment method is not fully configured choose some other payment method.', 'cyber-fundraiser-lite');
				$script_vars['configuration_error_message_4'] = __('Paypal payment method is not fully configured choose some other payment method.', 'cyber-fundraiser-lite');
				$script_vars['donation_amount_error_message1'] = __('Amount is invalid', 'cyber-fundraiser-lite');
				$script_vars['donation_amount_error_message2'] = __('You cannot donate more than '.$remaining_goal.' '.$currency, 'cyber-fundraiser-lite');
				$script_vars['donation_amount_error_message3'] = __('You cannot donate less than '.$script_vars['cf_settings']['general']['minimum_donation_amount'].' '.$currency, 'cyber-fundraiser-lite');
				$script_vars['title_for_basc'] = __('Direct Bank Transfer', 'cyber-fundraiser-lite');
				$script_vars['title_for_check_payment'] = __('Check Payment', 'cyber-fundraiser-lite');
				$script_vars['title_for_paypal_payment'] = __('Paypal Payment', 'cyber-fundraiser-lite');
				$script_vars['title_for_stripe_payment'] = __('Stripe Payment', 'cyber-fundraiser-lite');
				$script_vars['title_for_braintree_payment'] = __('BrainTree Payment', 'cyber-fundraiser-lite');
				$script_vars['payment_method_not_selected'] = __('select payment method first.', 'cyber-fundraiser-lite');
			}
			
			if(is_user_logged_in()){
				$script_vars['user_login'] = true;
				$script_vars['login_id'] = get_current_user_id();
			}else{
				$script_vars['user_login'] = 0;
				$script_vars['login_id'] = 0;
			}
			$script_vars['request_uri']  = $_SERVER['REQUEST_URI'];
			wp_localize_script( 'cyber-fundraising-frontend-script', 'script_vars', $script_vars );
			wp_enqueue_script( 'cyber-fundraising-frontend-script');
			wp_enqueue_script( 'cyber-fundraising-scroller', CYBER_FRL_ROOT_URL. '/assets/js/frontend/jquery.simplyscroll.js', array('jquery'), '1.0.0', true  );
		}

	}	
		$var = new Cyber_Fundraiser_layout();
}
?>