<?php 
if ( ! class_exists( 'Cyber_frl_Shortcodes' ) ) :
class Cyber_frl_Shortcodes {

	private $get_payment_settings;

    public function __construct()
    {
        add_shortcode('cyber_checkout', array($this, 'cyber_checkout_callback'));
       
    
        // enqueue Bootstrap
        add_action( 'wp_enqueue_scripts', array($this,'cyber_fundraiser_frontend_scripts' ) );

        add_action( 'wp_ajax_save_data_to_session', array($this,'save_data_to_session_callback' ));
		
		add_action( 'wp_ajax_nopriv_save_data_to_session', array($this,'save_data_to_session_callback' ));

		//insert donation
		add_action( 'wp_ajax_insert_donation', array($this,'insert_donation_callback' ));
		add_action( 'wp_ajax_nopriv_insert_donation', array($this,'insert_donation_callback' ));


    }


    function save_data_to_session_callback() {

        	$_SESSION['donating_user_data'] = array(
				'donateBy'   => sanitize_text_field($_POST['data']['donateBy']),
				'billingCountry'   => sanitize_text_field($_POST['data']['billingCountry']),
				'title'   => sanitize_text_field($_POST['data']['title']),
				'firstName'   => sanitize_text_field($_POST['data']['firstName']),
				'middleName'   => sanitize_text_field($_POST['data']['middleName']),
				'lastName'   => sanitize_text_field($_POST['data']['lastName']),
				'companyName'   => sanitize_text_field($_POST['data']['companyName']),
				'addressName'   => sanitize_text_field($_POST['data']['addressName']),
				'cityName'   => sanitize_text_field($_POST['data']['cityName']),
				'zipCode'   => sanitize_text_field($_POST['data']['zipCode']),
				'emailAddress'   => sanitize_text_field($_POST['data']['emailAddress']),
				'phone'   => sanitize_text_field($_POST['data']['phone']),
				'projectID'   => sanitize_text_field($_POST['data']['projectID']),
				'childProjectID'   => sanitize_text_field($_POST['data']['childProjectID']),
				'donorComments'   => sanitize_text_field($_POST['data']['donorComments']),
				'donationType'    => sanitize_text_field($_POST['data']['donationType'])
			);

			echo json_encode($_SESSION['donating_user_data']);


        die(0);
}
	/*	//	//	//	//	//	//	//	//	//	//	//	//	//	//	//	//
	/*  if donation is via direct bank transfer, check,         	//
	/*	Stripe, Braintree this function will be called through		//
	/*	ajax and data will be passes via url, otherwise function	//
	/*	will be called directly and argument will be passes 		//
	*/	//	//	//	//	//	//	//	//	//	//	//	//	//	//	//	//
	
	public function insert_donation_callback($data=false, $payment_type =false  ){
		global $wpdb;
		
		// Retrieving session data 
		$sessionData = isset($_SESSION['donating_user_data']) ? $_SESSION['donating_user_data'] : '';
		
		$donateBy = isset($sessionData['donateBy']) ? $sessionData['donateBy'] : '' ;
		
		$billingCountry = isset($sessionData['billingCountry']) ? $sessionData['billingCountry'] : '' ;
		
		$title = isset($sessionData['title']) ? $sessionData['title'] : '';
		
		$firstName = isset($sessionData['firstName']) ? $sessionData['firstName'] : '';
		
		$middleName = isset($sessionData['middleName']) ? $sessionData['middleName'] : '';
		
		$lastName = isset($sessionData['lastName']) ? $sessionData['lastName'] : '';
		
		$companyName = isset($sessionData['companyName']) ? $sessionData['companyName'] : '';
		
		$addressName = isset($sessionData['addressName']) ? $sessionData['addressName'] : '';
		
		$cityName = isset($sessionData['cityName']) ? $sessionData['cityName'] : '';
		
		$zipCode = isset($sessionData['zipCode']) ? $sessionData['zipCode'] : '';
		
		$emailAddress = isset($sessionData['emailAddress']) ? $sessionData['emailAddress'] : '';
		
		$phone = isset($sessionData['phone']) ? $sessionData['phone'] : '';
		
		$projectID = isset($sessionData['projectID']) ? $sessionData['projectID'] : '';
		
		$childProjectID = isset($sessionData['childProjectID']) ? $sessionData['childProjectID'] : '';
		
		$donorComments = isset($sessionData['donorComments']) ? $sessionData['donorComments'] : '';
		
		$donationType = isset($sessionData['donationType']) ? $sessionData['donationType'] : '';

		// geting currency type
		$currency = isset($this->settings['general']['currency']) ? $this->settings['general']['currency'] : 'USD' ;
		
		$new_recurring = '';
		
		// check for if payment method is paypal or others	
		if(!$payment_type){
			
			$paymentType = isset($_POST['data']['paymentType']) ? sanitize_text_field($_POST['data']['paymentType']) : '' ;
			
			$paymentAmount = isset($_POST['data']['paymentAmount']) ? sanitize_text_field($_POST['data']['paymentAmount']) : '';		
			
			$payment_status = isset($_POST['data']['payment_status']) ? sanitize_text_field($_POST['data']['payment_status']) : 'Pending';
			
			$transaction_id = isset($_POST['data']['transaction_id']) ? sanitize_text_field($_POST['data']['transaction_id']) : '';
			
			$customerId = isset($_POST['data']['customer_id']) ? sanitize_text_field($_POST['data']['customer_id']) : '';
		}else{
			
			$paymentAmount = $data['amt']."(".$currency.")";
			
			$payment_status = $data['st'];
			
			$transaction_id = $data['tx'];
			
			$paymentType = 'Paypal' ;
			
			}
		
		//	inserting the donation here

		$table_name_donation = $wpdb->prefix .'cyber_donations';
		
		$table_name_guest_donation = $wpdb->prefix .'cyber_guest_donations';
		
		//	if the user is logged in 
		//	update the user meta with the fields
		if(!$wpdb->get_results("SELECT `transaction_id` FROM `wp_cyber_donations` WHERE `transaction_id` = '".$transaction_id."' && `paid_via` != 'Direct Bank Transfer' && `paid_via` != 'Cheque Payment'" )){
		//	and insert the data to donation only with user id
			if(is_user_logged_in()){
				// updating user meta if logged in
					$user_id = get_current_user_id();
					$recurring_donations = get_user_meta($user_id, 'recurring_donations', true);
					if($donationType != 'one-time' && !empty($donationType)){
						$next_renewel = cf_next_recurring($donationType);
						$new_recurring = array(
												'project_id'	=>	 $projectID,
												'customer_id'	=>	 $customerId,
												'payment_gateway' => $paymentType,
												'amount'		 =>	 $paymentAmount,
												'donation_type'	=>	$donationType,
												'first_recurring' => time(),
												'last_recurring' => time(),
												'renewel_date'	=>	 $next_renewel,
												'recurrings'	=>	1,
												'status'	=>	1
											);
						if(empty($recurring_donations) || !is_array($recurring_donations)){
							$recurring_donations = array();
							array_push($recurring_donations, $new_recurring);
						}else{
							array_push($recurring_donations, $new_recurring);
						}
					}
					update_user_meta( $user_id, 'country', $billingCountry );
					update_user_meta( $user_id, 'title', $title );
					update_user_meta( $user_id, 'fname', $firstName );
					update_user_meta( $user_id, 'mname', $middleName );
					update_user_meta( $user_id, 'lname', $lastName );
					update_user_meta( $user_id, 'comp_name', $companyName );
					update_user_meta( $user_id, 'address', $addressName );
					update_user_meta( $user_id, 'city_name', $cityName );
					update_user_meta( $user_id, 'zipcode', $zipCode );
					update_user_meta( $user_id, 'email', $emailAddress );
					update_user_meta( $user_id, 'phone', $phone );
					update_user_meta( $user_id, 'recurring_donations', $recurring_donations );
					
				$wpdb->insert( 
					$table_name_donation, 
					array(
						'user_id' => get_current_user_id(), 
						'donation_amount' => $paymentAmount,
						'paid_via' => $paymentType, 
						'payment_status' => $payment_status,
						'project_id' => $projectID,
						'child_project_id' => $childProjectID,
						'donor_comments' => $donorComments,
						'date_created' => current_time('mysql'),
						'transaction_id' => $transaction_id
					) 
				);
				
					$new_insert_id = $wpdb->insert_id;
				//update user meta with new session data
			}else{

				//inserting the data to guest donation
				$wpdb->insert( 
					$table_name_guest_donation, 
					array(
						'country' => $billingCountry,
						'title'	=>	$title,
						'fname' => $firstName,
						'mname' => $middleName,						
						'lname' => $lastName, 
						'comp_name' =>$companyName,
						'address' => $addressName, 
						'city_name' => $cityName, 
						'zipcode' => $zipCode, 
						'email' => $emailAddress, 
						'phone' => $phone
					) 
				);
				$insert_id = $wpdb->insert_id;
				// now insert into donation with guest_id = insert_id
				$wpdb->insert( 
					$table_name_donation, 
					array( 
						'guest_id' => $insert_id, 
						'donation_amount' => $paymentAmount,
						'transaction_id' => $transaction_id,
						'paid_via' => $paymentType, 
						'payment_status' => $payment_status,
						'project_id' => $projectID,
						'child_project_id' => $childProjectID,
						'donor_comments' => $donorComments,
						'transaction_id' => $transaction_id,
						'date_created' => current_time('mysql')
					) 
				);	
				$new_insert_id = $wpdb->insert_id;
			}
		}
		if($new_insert_id && (!empty($projectID) || $projectID > 0) ){
			$projecDetails = cyber_frl_get_project_detail($projectID);
			update_post_meta($projectID, 'total_raised_amount', $projecDetails['amount_raised']);
			$projecDetails = cyber_frl_get_project_detail($projectID);
			if($projecDetails['status']==='Closed'){
				update_post_meta($projectID, 'status', 'Closed');
			}
		}
		// do action
		// allow developer to add more functionality
		do_action( 'cf_donation_added', $new_insert_id ) ;
		if($new_insert_id){
			if($donationType != 'one-time' && !empty($donationType)){
				$data = array(  
							'donator_name' =>	$title." ".$firstName." ".$lastName,
							'donation_amount' => $paymentAmount,
							'transaction_id' => $transaction_id,
							'paid_via' => $paymentType, 
							'recurring_status' => $new_recurring['status'],
							'project_id' => $projectID,
							'donation_id' => $new_insert_id,
							'duration'	=> $donationType,
							'recuring_time' => $new_recurring['last_recurring'],
							'next_recurring' => $new_recurring['next_renewel']
						);
				// Send Email
				$Send_Email = new Cyber_frl_Send_Email;
				$Send_Email-> cyber_fundraiser_send_email($emailAddress, 'new_recurring', 'Thank You', $data);
				
			}else{
				$data = array(  
							'donator_name' =>	$title." ".$firstName." ".$lastName,
							'donation_amount' => $paymentAmount,
							'transaction_id' => $transaction_id,
							'paid_via' => $paymentType, 
							'payment_status' => $payment_status,
							'project_id' => $projectID,
							'donation_id' => $new_insert_id
						);
				// Send Email
				$Send_Email = new Cyber_frl_Send_Email;
				$Send_Email-> cyber_fundraiser_send_email($emailAddress, 'new_fundraising', 'Thank You', $data);
			}
			if(!$payment_type){
				echo $new_insert_id;
			}else{
				return $new_insert_id;
				}
		}else{
			return false;
		}
		die();
	}


    /**
	 * Proper way to enqueue scripts and styles.
	 */
	public function cyber_fundraiser_frontend_scripts() {
		global $post;
		if($post->post_type == 'projects' || $post->post_type == 'docs'|| is_page( array('cyber-fundraiser-checkout','cyber-fundraiser-success-donation', 'child-project','cf-docs'))){
			wp_enqueue_style( 'bootstrap-style', CYBER_FRL_ROOT_URL. '/assets/css/frontend/bootstrap.min.css' );
			wp_enqueue_style( 'bootstrap-style', CYBER_FRL_ROOT_URL. '/assets/css/frontend/bootstrap-theme.min.css' );
			wp_enqueue_script( 'bootstrap-script', CYBER_FRL_ROOT_URL. '/assets/js/frontend/bootstrap.min.js', array(), '1.0.0', true );

			//date picker
			wp_enqueue_script('jquery-ui-datepicker');
			//front end form validation
			wp_enqueue_script('jquery-form-validation','http://ajax.aspnetcdn.com/ajax/jquery.validate/1.9/jquery.validate.js');

			wp_enqueue_style('jquery-style', 'http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.2/themes/smoothness/jquery-ui.css');

			//image load from front end
			 wp_enqueue_media();

		}
	}


     
    public function cyber_checkout_callback($atts)
    {

    	$atts = shortcode_atts(
		array(
			'project_id' => '0'
		), 
		$atts, 'cyber_checkout' );

    	$this->get_settings();

    	require('views/checkout.php');
    }


 public function cyber_success_donation_callback($atts)
    {

    	$atts = shortcode_atts(
		array(
			'project_id' => '0'
		), 
		$atts, 'cyber_success_donation' );

    	$this->get_settings();

    	require('views/success_page.php');
    }


    public function save_paypal_donation($data)
    {

    	//inserting the donation here

		global $wpdb;

		$table_name_donation = $wpdb->prefix.'cyber_donations';
		$table_name_guest_donation = $wpdb->prefix.'cyber_guest_donations';


    	// check if the user is logged in

    	// if the user is logged in 
		//update the user meta with the fields
		//and insert the data to donation only with user id

		if(is_user_logged_in()){


			$wpdb->insert( 
				$table_name_donation, 
				array( 
					'user_id' => get_current_user_id(), 
					'donation_amount' => $data['mc_gross'],
					'paid_via' => 'Paypal', 
					'payment_status' => $data['payment_status'],
					'date_created' => current_time('mysql')
				), 
				array( 
					'%d', 
					'%d',
					'%s',
					'%s',
					'%s',
				) 
			);


			//update user meta with new session data


		}else{


			//inserting the data to guest donation
			$wpdb->insert( 
				$table_name_guest_donation, 
				array( 
					'country' => $databillingCountry,
					'fname' => $sessionData->firstName, 
					'mname' => $sessionData->lastName,
					'lname' => $sessionData->lastName,  
					'comp_name' =>$sessionData->companyName,
					'address' => $sessionData->addressName, 
					'city_name' => $sessionData->cityName, 
					'zipcode' => $sessionData->zipCode, 
					'email' => $sessionData->emailAddress, 
					'phone' => $sessionData->phone
				), 
				array( 
					'%s', 
					'%s',
					'%s',
					'%s',
					'%s',
					'%s',
					'%d',
					'%s',
					'%d',
				) 
			);


			$insert_id = $wpdb->insert_id;

			// now insert into donation with guest_id = insert_id
			$wpdb->insert( 
				$table_name_donation, 
				array( 
					'guest_id' => $insert_id, 
					'donation_amount' => $data['mc_gross'],
					'paid_via' => 'Paypal', 
					'payment_status' => $data['payment_status'],
					'date_created' => current_time('mysql')
				), 
				array( 
					'%d', 
					'%d',
					'%s',
					'%s',
					'%s',
				) 
			);


		}


    }


    /**
	 * Gettings All Options from options table
	 * @return Array
	 */
	
	public function get_settings(){

		return $this->settings = get_option( 'cyber_fundraiser_settings' );
	}
}
 
$CyberDonation = new Cyber_frl_Shortcodes();
endif;
?>