<?php
if(!function_exists('cyber_frl_paypal_shortcode')){
	function cyber_frl_paypal_shortcode(){
		if((isset($_POST['paypal_submit']) && isset($_POST['paypal-method'])) || isset($_GET['status'])){
			$settings = get_option( 'cyber_fundraiser_settings' );
			$currency = $settings['general']['currency'];
			if($currency != '' ){ $currency = $currency ; }else{  $currency = "USD"; }
			
			$_SESSION['paypal']['method'] = sanitize_text_field($_POST['paypal-method']);
			$_SESSION['paypal']['creditcard']	= sanitize_text_field($_POST['user']['credit_card']);
			$_SESSION['paypal']['currency'] = $currency;
			$_SESSION['paypal']['returnSlug'] = 'cyber-fundraiser-checkout';
			$_SESSION['paypal']['cancelURL']= $_SERVER['REQUEST_URI'];
			unset($_POST['paypal']);
			unset($_POST['user']);
			unset($_POST['paypal_amount']);
			unset($_POST['paypal']);
			unset($_POST['paypal_submit']);
			if(isset($_GET['status'])){
				$_SESSION['paypal']['paymentId'] = sanitize_text_field($_GET['paymentId']);
				$_SESSION['paypal']['payerId'] = sanitize_text_field($_GET['PayerID']);
				header("Location: " . home_url().'/cyber-fundraiser-checkout/?paypal_status=true');
				exit();
			}else{
				$_SESSION['paypal']['amount'] = sanitize_text_field($_POST['amount']);
				header("Location: " . $_SERVER['REQUEST_URI'].'?paypal=true');
				exit();
			}
		}

		
		if((isset($_GET['paypal']) && isset($_SESSION['paypal'])) || (isset($_GET['paypal_status']) && sanitize_text_field($_GET['paypal_status']))){
			$paypalErrorMessage = false;
			$currency = $_SESSION['paypal']['currency'];
			$amount = $_SESSION['paypal']['amount'];
			if(isset($_GET['paypal_status']) && sanitize_text_field($_GET['paypal_status'])){
				try{
					$payment = cyber_frl_executePayment($_SESSION['paypal']['paymentId'], $_SESSION['paypal']['payerId']);
				}catch(Exception $ex){
					$paypalErrorMessage = $ex->getMessage();
				}
			}else{
				try {
						$returnUrl = home_url().'/'.$_SESSION['paypal']['returnSlug'].'?status=true';
						$cancelUrl = home_url().'/'.$_SESSION['paypal']['cancelURL'];
						$approvalLink = cyber_frl_makePaymentUsingPayPal($amount, $currency, 'Paypal Payment', $returnUrl, $cancelUrl);
						header("Location: " . $approvalLink);
						exit;
				} catch(\PayPal\Exception\PPConnectionException $ex){
					$paypalErrorMessage = $ex->getData() != '' ? parseApiError($ex->getData()) : $ex->getMessage();
				} catch (Exception $ex) {
					$paypalErrorMessage = $ex->getMessage();
				}
			}
			if(!$paypalErrorMessage){
				$payment_id = $payment->id;
				$transaction_id = $payment->id;
				$amount = $_SESSION['paypal']['amount'].'('.$currency.')';
				
				unset($_SESSION['paypal']);
				$cf_success_url='cyber-fundraiser-success-donation';
				?>
					<script>
						jQuery('#cf_checkout_main_container').css('display','none');
						
						
						var transaction_id= "<?php echo $transaction_id; ?>";
						
						var paymentAmount ="<?php echo $amount; ?>";
						var customer_id = "<?php echo $creditCardId; ?>";
						var ajaxurl = "<?php echo admin_url( 'admin-ajax.php' ); ?>";
						
						var data = {
							'paymentType' : 'Paypal',
							'paymentAmount' : paymentAmount,
							'transaction_id' : transaction_id,
							'payment_status' : 'Completed',
							'customer_id' 	 : customer_id,
						}
						jQuery.post(
							ajaxurl,
							{
								'action': 'insert_donation',
								'data' : data,
								processData: false,
							}, 
							function(response){
							window.location.href = "<?php echo home_url().'/'.$cf_success_url.'/'; ?>"+response;
							}
						);
					</script>
				<?php
			}else{
				?>
				
				<script>
					jQuery('#cf_checkout_main_container').css('display','none');
					jQuery('#cf-errors h1').text('<?php _e('Paypal Connection Error','cyber-fundraiser-lite'); ?>');
					jQuery('#cf-error').append(<?php echo "'".$paypalErrorMessage."'"; ?>);
					jQuery('#cf-try-again').attr('from','paypal');
					jQuery('#cf-errors').fadeIn('slow');
					jQuery('.cyber-checkout').fadeOut('slow');
					jQuery('.before-login-form').hide();
					jQuery('#configuration-error').hide();
					jQuery('#message').hide();
					
					jQuery('.login-form').hide();
					jQuery('#message').hide();
					jQuery('html, body').animate({
							scrollTop: jQuery("body").offset().top
					},1000);
					jQuery('#error-dismiss').click(function()
					{
						jQuery('.cyber-checkout').fadeIn('slow');
					});
				</script>
				<?php
			}
		}elseif(isset($_GET['paypal'])){
				header("Location: " . home_url());
				exit();
		}
		
	?>
		<form action="" method="post" class="paypal-form cf_hidedefault" accept-charset="UTF-8" autocomplete="off">
			<input type = "hidden" name = "amount" value = "">
			<div class = "cf_paypal-creditCard cf_hidedefault">
				<br/><br/><br/><br/><br/><br/>
				<div class = "form-group">
					<div class="col-md-6 control-group">
						<label class="control-label" for="user_credit_card_type"><abbr title="required">*</abbr> <?php _e('Card Type', 'cyber-fundraiser-lite'); ?></label>
						<div class="controls"><select style = "width:100%;" class="form-control" id="user_credit_card_type" name="user[credit_card][type]"><option value=""></option>
							<option value="visa" selected>visa</option>
							<option value="mastercard">mastercard</option>
							<option value="discover">discover</option>
							<option value="amex">amex</option></select>
						</div>
					</div>
				
					<div class=" col-md-6 control-group">
						<label class="control-label" for="user_credit_card_number"><abbr title="required">*</abbr> <?php _e('Card Number', 'cyber-fundraiser-lite'); ?></label>
						<div class="controls">
							<input class="form-control" id="user_credit_card_number" name="user[credit_card][number]" size="50" type="text" value="" />
						</div>
					</div>
				</div>
				<div class="form-group">
					<div class="col-md-4 control-group">
						<label class="control-label" for="user_credit_card_cvv2"><?php _e('Cvv', 'cyber-fundraiser-lite'); ?></label>
						<div class="controls">
							<input class="form-control" id="user_credit_card_cvv2" name="user[credit_card][cvv2]" size="50" type="text" value="" />
						</div>
					</div>
				
				
					<div class="col-md-4 control-group">
						<label class="control-label" for="user_credit_card_expire_month"><abbr title="required">*</abbr> <?php _e('Expire month', 'cyber-fundraiser-lite'); ?></label>
						<div class="controls">
							<select style = "width:100%;" class="form-control" id="user_credit_card_expire_month" name="user[credit_card][expire_month]">
								<option value="1"><?php _e('January', 'cyber-fundraiser-lite'); ?></option>
								<option value="2"><?php _e('Febraury', 'cyber-fundraiser-lite'); ?></option>
								<option value="3"><?php _e('March', 'cyber-fundraiser-lite'); ?></option>
								<option value="4"><?php _e('April', 'cyber-fundraiser-lite'); ?></option>
								<option value="5"><?php _e('May', 'cyber-fundraiser-lite'); ?></option>
								<option value="6"><?php _e('June', 'cyber-fundraiser-lite'); ?></option>
								<option value="7"><?php _e('July', 'cyber-fundraiser-lite'); ?></option>
								<option value="8"><?php _e('August', 'cyber-fundraiser-lite'); ?></option>
								<option value="9"><?php _e('September', 'cyber-fundraiser-lite'); ?></option>
								<option value="10"><?php _e('Actober', 'cyber-fundraiser-lite'); ?></option>
								<option value="11"><?php _e('November', 'cyber-fundraiser-lite'); ?></option>
								<option value="12"><?php _e('December', 'cyber-fundraiser-lite'); ?></option>
							</select>
						</div>
					</div>
					<div class="col-md-4 control-group">
						<label class="control-label" for="user_credit_card_expire_year"><abbr title="required">*</abbr> Expire year</label>
						<div class="controls">
							<select style = "width:100%;" class="form-control" id="user_credit_card_expire_year" name="user[credit_card][expire_year]">
								<?php $cYear = date('Y');
								$to = date('Y')+10;
								for($i=$cYear; $i<=$to; $i++){
									echo '<option value="' .$i. '">'. $i . '</option>';
								} ?>
							</select>
						</div>
					</div>
				</div>
				<!--<img alt="" border="0" src="https://www.paypalobjects.com/en_US/i/scr/pixel.gif" width="1" height="1">-->
			</div>
			<div class="col-md-4 col-sm-6 pull-right">
				<input type = "hidden" name = "amount" value = "">
				<input type = "hidden" name = "paypal-method" value = "paypal">
				<button type="submit" class ="btn-primary btn" border="0" id = "paypalButton" name="paypal_submit"><?php echo _e('Donate Now', 'cyber-fundraiser-lite');?></button>	
			</div>
		</form>
	<?php
	}
} 
add_shortcode('paypal-shortcode', 'cyber_frl_paypal_shortcode');