<?php
	if(!isset($this->settings['paymentgateway'])){ ?>
		<div class="alert alert-danger" role="danger">
			<h1><?php _e('Configuration Error', 'cyber-fundraiser-lite'); ?></h1>
			<p><?php _e('It seems that some necessary settings are not configured properly. Please Contact to Administration', 'cyber-fundraiser-lite'); ?></p>
		</div>
	<?php exit;}
	
	global $wp_query, $wpdb;
	//print_r($wp_query);
	$args = explode("/",$wp_query->query['args']);
	if(!empty($args[0])){
		$post = get_page_by_path( $args[0], OBJECT, 'projects' );
		if(!empty($post->ID)){
			$project_id=$post->ID;
		}else{
			$project_id=0;
		}
	}else{
		$project_id=0;
	}
	
	if(!empty($args[1])){
		$post = get_page_by_path( $args[1], OBJECT, 'projects' );
		if(!empty($post->ID)){
			$child_project_id=$post->ID;
		}else{
			$child_project_id=0;
		}	
	}else{
		$child_project_id=0;
	}
	$currency = $this->settings['general']['currency'];
	if(empty($currency)){
		$currency = 'USD';
	}
	if(!empty($this->settings['general']['minimum_donation_amount'])){
		$minimum_donation_amount = $this->settings['general']['minimum_donation_amount'];
	}else{
		$minimum_donation_amount=0;
	}

	$donation_table = $wpdb->prefix.'cyber_donations';
	// getting donations entries with  completed status
	$total_donated = $wpdb->get_var( $wpdb->prepare( 
	  " SELECT sum(donation_amount) FROM $donation_table WHERE project_id = %d AND payment_status = %s
	  ", 
	  $project_id,
	  'completed'
	) );

    $project_goal = esc_html(get_post_meta ($project_id, 'project_goal',true));
	$remaining_goal = $project_goal - $total_donated;
	$receive_donations_after_goal_is_acheived = esc_html(get_post_meta( $project_id, 'receive_donations_after_goal_is_acheived', true ));
	?>
<!-- Checkout page for donation -->
		
	<!-- Alert sections i.e in case of success and some errors -->
<div class = "cf_alerts">

	<div class="alert alert-danger cf-alert-danger" id="cf-errors"  role="danger" style = "display:none">
			
			<h1><?php _e('Invalid Braintree Account Information', 'cyber-fundraiser-lite'); ?></h1>
			
			<p id = "cf-error"></p>
			<div class = "cf-errors-btns">
				<button type='button'  class ="btn-xs" id = "cf-try-again" from = "" data-dismiss='alert'><?php _e('Try Again', 'cyber-fundraiser-lite'); ?></button>
				<button type='button'  class ="btn-xs" id = "error-dismiss" data-dismiss='alert'><?php _e('x Close', 'cyber-fundraiser-lite'); ?></button>
			</div>
	</div>

	<!-- 	Configuration message	-->
	<div class="alert alert-danger cf-configuration-error" id="configuration-error" role="danger"  style = "display:none">
			
			<h2><?php _e('Configuration Error:', 'cyber-fundraiser-lite'); ?></h2>
	</div> 
		
	<!-- 	alsert if project id is null	-->
	
	<div class="alert alert-warning cf-warning-message" id="message"  role="alert"  style = "display:none">
			
			<p><h3><?php _e('Note:</h3> Are you sure that you are donating directly to', 'cyber-fundraiser-lite'); ?> <?php echo $_SERVER['HTTP_HOST']; ?> <?php _e('rather than any project. If not then please select a project first and donate.<br>Thanks!  ', 'cyber-fundraiser-lite'); ?> </p>
			<button type='button' class='close' data-dismiss='alert'><?php _e('X Close', 'cyber-fundraiser-lite'); ?></button>
	</div>

	<!-- End Alert sections i.e in case of success and some errors -->
</div>
		<!-- Login , sign up, Create new account	-->
<div id="cf_checkout_main_container">
	<div class="panel panel-default cf-before-login-form"  id = "before-login-form"  style = "display:none">
	    
	    <div class="panel-heading cf_panel-heading" role="tab" id="headingOne">
	    
		      <h4 class="panel-title">
		      
		        <a role="button" data-toggle="collapse" data-parent="#accordion" href="#collapseOne" aria-expanded="true" aria-controls="collapseOne">
		         
		          <?php _e('DONATE AS', 'cyber-fundraiser-lite'); ?>
		        </a>
		      </h4>
	    </div>
	    
	    <div id="collapseOne" class="panel-collapse collapse in" role="tabpanel" aria-labelledby="headingOne">
	      
	      <div class="panel-body row">
	      	
	      	<div class="col-md-12">
				
				<button type="button" class="btn btn-info cf_checkout_btn" id = "login"><?php _e('LOGIN', 'cyber-fundraiser-lite'); ?></button>
	      		
	      		<button type="button" class="btn btn-info cf_checkout_btn" id = "as-guest"><a href="#billing-details"><?php _e('GUEST', 'cyber-fundraiser-lite'); ?></a></button>
				
				<button type="button" class="btn btn-info cf_checkout_btn" id = "register"><?php _e('SIGN UP', 'cyber-fundraiser-lite'); ?></button>
	      	</div>

	      </div>

	    </div>

	 </div>

	 <?php 

		$actual_link = "http://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";
	    
	    $_SESSION['previous_location'] = $actual_link;

	?> 

	<div class="wrap cyber-checkout"  style = "display:none">

	    <div class="clear"></div>

		<div class="payment_methods">

			<!-- bacs  -->
			<?php if($this->settings['paymentgateway']['bacs']['enable'] == 'on'): ?>
				
				<label class="radio-inline">
				
				  <input type="radio" name="payment_cycle" id="payment_basc" value="direct_bank_transfer" <?php checked( $this->settings['paymentgateway']['default'], 'bacs' ); ?>><?php _e('Direct Bank Transfer', 'cyber-fundraiser-lite'); ?> 
				</label>
			
			<?php endif; ?>

				<!-- cheque   -->

			<?php if($this->settings['paymentgateway']['cheque']['enable'] == 'on'): ?>
			
				<label class="radio-inline">
				
				  <input type="radio" name="payment_cycle" id="payment_cheque" value="check_payment" <?php checked( $this->settings['paymentgateway']['default'], 'cheque' ); ?>><?php _e('Check Payment', 'cyber-fundraiser-lite'); ?> 
				</label>
			
			<?php endif; ?>

				<!-- Paypal  -->

			<?php if($this->settings['paymentgateway']['paypal']['enable'] == 'on'): ?>
				
				<label class="radio-inline">
				  
				  <input type="radio" name="payment_cycle" id="payment_paypal" 
				  value="paypal_payment" <?php checked( $this->settings['paymentgateway']['default'], 'paypal' ); ?>> <?php _e('Paypal', 'cyber-fundraiser-lite'); ?>
				</label>
			
			<?php endif; ?>

		</div> 
		
		<div class="panel-group" id="accordion" role="tablist" aria-multiselectable="true">

			<div class="panel panel-default cf_hidedefault" id="billing-details" >
			    
			    <div class="panel-heading cf_panel-heading" role="tab" id="headingTwo">
			     
			      <h4 class="panel-title">
			       
			        <a class="collapsed" role="button" data-toggle="collapse" data-parent="#accordion" href="#collapseTwo" aria-expanded="false" aria-controls="collapseTwo">
			          <?php _e('DONOR INFORMATION', 'cyber-fundraiser-lite'); ?>
			        </a>

			      </h4>

			    </div>

			    <div id="collapseTwo" class="panel-collapse collapse in" role="tabpanel" aria-labelledby="headingTwo">
			     
					<div class="panel-body">
						<?php require_once CYBER_FRL_ROOT_PATH.'/includes/shortcodes/views/checkout-parts/billing-details.php'; ?>
					</div>

	  			</div>

	 		 </div>


			<div class="panel panel-default cf_hidedefault"  id="payment-details">
			   
			    <div class="panel-heading cf_panel-heading" role="tab" id="headingThree">
			     
			      <h4 class="panel-title">
			       
			        <a class="collapsed" role="button" data-toggle="collapse" data-parent="#accordion" href="#collapseThree" aria-expanded="false" aria-controls="collapseThree"><?php _e(' PAYMENT INFORMATION', 'cyber-fundraiser-lite'); ?>
			        </a>
			      </h4>

			    </div>

			    <div id="collapseThree" class="panel-collapse collapse" role="tabpanel" aria-labelledby="headingThree">

					<div class="panel-body">
						<?php require_once CYBER_FRL_ROOT_PATH.'/includes/shortcodes/views/checkout-parts/direct-bank-transfer.php'; ?>
						<!-- End of BACS Payment -->
						<?php require_once CYBER_FRL_ROOT_PATH.'/includes/shortcodes/views/checkout-parts/cheque-payment.php'; ?>
						<!-- End of Cheque Payment -->
						<?php require_once CYBER_FRL_ROOT_PATH.'/includes/shortcodes/views/checkout-parts/paypal-payment.php'; ?>
						<!-- End of paypal Payment -->
					</div>

			    </div>

			</div>


			<div class="panel panel-default cf_hidedefault" id="confirm-payment">
			    
			    <div class="panel-heading cf_panel-heading" role="tab" id="headingFour">
			      
				      <h4 class="panel-title">
				        <a class="collapsed" role="button" data-toggle="collapse" data-parent="#accordion" href="#collapsefour" aria-expanded="false" aria-controls="collapsefour">
				         <?php _e('CONFIRM DONATION', 'cyber-fundraiser-lite'); ?>
				        </a>
				      </h4>

			    </div>

			    <div id="collapsefour" class="panel-collapse collapse" role="tabpanel" aria-labelledby="headingFour">
			     
					<div class="panel-body">

			      		<h4><?php _e('Your Payment Details', 'cyber-fundraiser-lite'); ?></h4>
			        	
			        	<div class="col-md-8 col-sm-12">

			        		<table class="table table-bordered"> 
								
								<colgroup> 
									<col class="col-xs-4"> 
										<col class="col-xs-7"> 
								</colgroup> 

								<tbody> 

									<tr> 
										<th scope="row"> 
											<?php _e('PAYMENT TYPE', 'cyber-fundraiser-lite'); ?>
										</th> 
										<td><span class="confirm-payment-type"></span></td> 
									</tr> 

									<tr> 
										<th scope="row"> 
											<?php _e('DONATION AMOUNT', 'cyber-fundraiser-lite'); ?>
										</th> 
										<td><span class="confirm-donation-amount"></span> (<?php if($this->settings['general']['currency'] != ''){ echo $this->settings['general']['currency']; }else{ echo 'USD'; } ?>)</td> 
									</tr> 	
					
					 		</tbody> 

						</table>


			        	</div>

			        	<div class="col-md-4 col-sm-6 pull-right">
			        		
			        		<div class="pull-right"><br/><br/>
			        				
			        				<button class="btn-primary btn donate-now cf_hidedefault"><?php _e('Donate Now', 'cyber-fundraiser-lite'); ?></button>

							</div>

						</div>
						
						<!-- Paypal Form -->
						<div class="paypal-form cf_hidedefault">
						<?php
							echo do_shortcode('[paypal-shortcode]');
						?>
						</div>

					</div>

			    </div>

			</div>

		</div>

	</div>
</div>
<div class = "cf_checkout_loader">
				<span id = "cf_loader"> </span>
</div>
<style>
.cf_checkout_loader{
	display:none;
	margin-left:45%;
}
</style>