<?php
if ( ! class_exists( 'Cyber_Donation_Widget' ) ) :
class Cyber_Donation_Widget extends WP_Widget {
    public function __construct() {
        parent::__construct(
            'cyber_donation_widget',
            __( 'Cyber Fundraiser Donation Button', 'cyber-fundraiser-lite' ),
            array(
                'classname'   => 'cyber_donation_widget',
                'description' => __( 'A widget for Donation to the Site/Organization.', 'cyber-fundraiser-lite' )
                )
        );  
    }
    /**  
     * Front-end display of widget.
     *
     * @see WP_Widget::widget()
     *
     * @param array $args     Widget arguments.
     * @param array $instance Saved values from database.
     */
    public function widget( $args, $instance ) {    
        extract( $args );
     
        $title      = apply_filters( 'widget_title', $instance['title'] );
       
        $donate_btn_text    = $instance['donate_btn_text'];
       
        echo $before_widget;         
        if ( $title ) {
            echo $before_title . $title . $after_title;
        }  
        echo '<div  class = "cyber-donation-widget widget cf_widget"><a href="'.site_url() . '/cyber-fundraiser-checkout"><button class="btn btn-primary btn-lg cf_donate-widget">'.$donate_btn_text.'</button></a></div>';
        echo $after_widget;    
    }
    /**
      * Sanitize widget form values as they are saved.
      *
      * @see WP_Widget::update()
      *
      * @param array $new_instance Values just sent to be saved.
      * @param array $old_instance Previously saved values from database.
      *
      * @return array Updated safe values to be saved.
      */
  
    public function update( $new_instance, $old_instance ) {    
     
        $instance = $old_instance;   
      
        $instance['title'] = strip_tags( $new_instance['title'] );
      
        $instance['donate_btn_text'] = strip_tags( $new_instance['donate_btn_text'] );
        return $instance;    
    }
    /**
      * Back-end widget form.
      *
      * @see WP_Widget::form()
      *
      * @param array $instance Previously saved values from database.
      */
   
    public function form( $instance ) {         
       
        $title      = esc_attr( $instance['title'] );
       
        $donate_btn_text    = esc_attr( $instance['donate_btn_text'] );
?>       
        <p>
           
            <label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:','cyber-fundraiser-lite'); ?></label> 
           
            <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" />
        </p>


        <p>
            
            <label for="<?php echo $this->get_field_id('donate_btn_text'); ?>"><?php _e('Donate Button Text', 'cyber-fundraiser-lite'); ?></label> 
           
            <input class="widefat" type="text" id="<?php echo $this->get_field_id('donate_btn_text'); ?>" name="<?php echo $this->get_field_name('donate_btn_text'); ?>" value="<?php echo $donate_btn_text; ?>" />
        </p>    
<?php 
    }
     
}

/* Register the widget */
  add_action( 'widgets_init', function(){
   
     register_widget( 'Cyber_Donation_Widget' );
  });

$Create_widget = new Cyber_Donation_Widget();
endif;
?>