<?php
/*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*/
/*				Twitter Feeds Widgets shortcode				*/
/*	*	*	*	*	*	*	*	*	*	*	*	*	*	*	*/
if( !class_exists( 'Cyber_twitterfeeds_Widget' ) ) {
	
	class Cyber_twitterfeeds_Widget extends WP_Widget {
		
		public function __construct() {
			
			$widget = array('classname' => 'cyber_twitterfeeds_widget', 'description' => __('Cyber Fundraiser Widget for Twitter feeds.', 'cyber-fundraiser-lite'));
			
			$control = array('width' => 400, 'height' => 300);
			
			parent::__construct('cyber-twitterfeeds-widget', __('Cyber Fundraiser Twitter Feeds', 'cyber-fundraiser-lite'), $widget, $control);
		}
		
		
		public function widget( $args, $instance ) {
			
			extract( $instance );
			
			$title = apply_filters( 'widget_title', empty( $instance['title'] ) ? '' : $instance['title'], $instance, $this->id_base );
			
			echo $args['before_widget'];
			
			if ( ! empty( $title ) ) {
				
				echo $args['before_title'];  _e($title, 'cyber-fundraiser-lite'); $args['after_title'];
			} 
			
			if($twitter_name != '' ){ $twitter_name = $twitter_name ; }else{  $twitter_name = 'TwitterDev '; }
			

			if($container_width != '' ){ $container_width = $container_width ; }else{ $container_width =  '240px '; }
			

			if($container_height != '' ){ $container_height = $container_height ; }else{  $container_height = '240px '; }
			

			$text = do_shortcode('[twitter_tweets_feeds twitter_name = '.$twitter_name.' width = '.$container_width.' height = '.$container_height.']');
			
			echo $args['after_widget'];
		}
		
		public function update( $new_instance, $old_instance ) {
			
			$instance = $old_instance;
			
			$instance['title'] = strip_tags($new_instance['title']);
			
			$instance['twitter_name'] = strip_tags($new_instance['twitter_name']);
			
			$instance['container_width'] = $new_instance['container_width'];
			
			$instance['container_height'] = $new_instance['container_height'];
			
			return $instance;
		}


		public function form( $instance ) {
			
			
			$instance = wp_parse_args( (array) $instance, array( 'title' => '', 'twitter_name' => 'TwitterDev' ) );
		
			$title = strip_tags($instance['title']);
		
			$twitter_name = strip_tags($instance['twitter_name']);
		
			$container_width = $instance['container_width'];
		
			$container_height = $instance['container_height'];
			?>
				
				<p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:', 'cyber-fundraiser-lite'); ?></label>
						<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($title); ?>" />
				</p>


				<p><label for="<?php echo $this->get_field_id('twitter_name'); ?>"><?php _e('Your Twitter Name:', 'cyber-fundraiser-lite'); ?></label>
						<input class="widefat" id="<?php echo $this->get_field_id('twitter_name'); ?>" name="<?php echo $this->get_field_name('twitter_name'); ?>" type="text" value="<?php echo esc_attr($twitter_name); ?>" />
				</p>


				<p><label for="<?php echo $this->get_field_id( 'container_width' ); ?>"><?php _e( 'Container Width:', 'cyber-fundraiser-lite' ); ?></label>
						<input class="widefat" id="<?php echo $this->get_field_id('container_width'); ?>" name="<?php echo $this->get_field_name('container_width'); ?>" type="text" value="<?php echo esc_attr($container_width); ?>" />
				</p>
				
				<p><label for="<?php echo $this->get_field_id( 'container_height' ); ?>"><?php _e( 'Container Height:', 'cyber-fundraiser-lite' ); ?></label>
						<input class="widefat" id="<?php echo $this->get_field_id( 'container_height' ); ?>" name="<?php echo $this->get_field_name('container_height'); ?>" type="text" value="<?php echo esc_attr($container_height); ?>" />
				</p>
				
			<?php
		}
		
	}
}
if(!function_exists('cyber_twitterfeeds_widget_init')){
	function cyber_twitterfeeds_widget_init(){
		
		register_widget('Cyber_twitterfeeds_Widget');
	}
}	
	add_action('widgets_init','cyber_twitterfeeds_widget_init');
?>